/* AsyncTask.c generated by valac 0.44.11, the Vala compiler
 * generated from AsyncTask.vala, do not modify */

/*
 * AsyncTask.vala
 *
 * Copyright 2012-2018 Tony George <teejeetech@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 *
 *
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>
#include <gio/gunixoutputstream.h>
#include <gio/gunixinputstream.h>
#include <unistd.h>

#define TYPE_ASYNC_TASK (async_task_get_type ())
#define ASYNC_TASK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ASYNC_TASK, AsyncTask))
#define ASYNC_TASK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ASYNC_TASK, AsyncTaskClass))
#define IS_ASYNC_TASK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ASYNC_TASK))
#define IS_ASYNC_TASK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ASYNC_TASK))
#define ASYNC_TASK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ASYNC_TASK, AsyncTaskClass))

typedef struct _AsyncTask AsyncTask;
typedef struct _AsyncTaskClass AsyncTaskClass;
typedef struct _AsyncTaskPrivate AsyncTaskPrivate;
typedef enum  {
	APP_STATUS_NOT_STARTED,
	APP_STATUS_RUNNING,
	APP_STATUS_PAUSED,
	APP_STATUS_FINISHED,
	APP_STATUS_CANCELLED,
	APP_STATUS_PASSWORD_REQUIRED
} AppStatus;

#define TYPE_APP_STATUS (app_status_get_type ())
enum  {
	ASYNC_TASK_0_PROPERTY,
	ASYNC_TASK_STAT_TIME_ELAPSED_PROPERTY,
	ASYNC_TASK_STAT_TIME_REMAINING_PROPERTY,
	ASYNC_TASK_NUM_PROPERTIES
};
static GParamSpec* async_task_properties[ASYNC_TASK_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_timer_destroy0(var) ((var == NULL) ? NULL : (var = (g_timer_destroy (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
enum  {
	ASYNC_TASK_STDOUT_LINE_READ_SIGNAL,
	ASYNC_TASK_STDERR_LINE_READ_SIGNAL,
	ASYNC_TASK_TASK_COMPLETE_SIGNAL,
	ASYNC_TASK_NUM_SIGNALS
};
static guint async_task_signals[ASYNC_TASK_NUM_SIGNALS] = {0};

struct _AsyncTask {
	GObject parent_instance;
	AsyncTaskPrivate * priv;
	GDataOutputStream* dos_log;
	gboolean is_terminated;
	GPid child_pid;
	gchar* script_file;
	gchar* working_dir;
	gchar* log_file;
	gboolean background_mode;
	AppStatus status;
	gchar* status_line;
	gint exit_code;
	gchar* error_msg;
	GTimer* timer;
	gdouble progress;
	gdouble percent;
	gint64 prg_count;
	gint64 prg_count_total;
	gint64 prg_bytes;
	gint64 prg_bytes_total;
	gchar* eta;
};

struct _AsyncTaskClass {
	GObjectClass parent_class;
	void (*parse_stdout_line) (AsyncTask* self, const gchar* out_line);
	void (*parse_stderr_line) (AsyncTask* self, const gchar* err_line);
	void (*finish_task) (AsyncTask* self);
};

struct _AsyncTaskPrivate {
	gchar* err_line;
	gchar* out_line;
	GDataOutputStream* dos_in;
	GDataInputStream* dis_out;
	GDataInputStream* dis_err;
	gboolean stdout_is_open;
	gboolean stderr_is_open;
	gint input_fd;
	gint output_fd;
	gint error_fd;
	gboolean finish_called;
};

static gint AsyncTask_private_offset;
static gpointer async_task_parent_class = NULL;
extern gchar* tee_jee_process_helper_TEMP_DIR;

GType async_task_get_type (void) G_GNUC_CONST;
GType app_status_get_type (void) G_GNUC_CONST;
AsyncTask* async_task_construct (GType object_type);
gchar* tee_jee_misc_timestamp_for_path (void);
gchar* tee_jee_file_system_path_combine (const gchar* path1,
                                         const gchar* path2);
gboolean tee_jee_file_system_dir_create (const gchar* dir_path,
                                         gboolean show_message);
gboolean async_task_begin (AsyncTask* self);
void async_task_set_priority (AsyncTask* self);
void tee_jee_logging_log_debug (const gchar* message);
static void async_task_read_stdout (AsyncTask* self);
static gpointer _async_task_read_stdout_gthread_func (gpointer self);
void tee_jee_logging_log_error (const gchar* message,
                                gboolean highlight,
                                gboolean is_warning);
static void async_task_read_stderr (AsyncTask* self);
static gpointer _async_task_read_stderr_gthread_func (gpointer self);
void async_task_parse_stdout_line (AsyncTask* self,
                                   const gchar* out_line);
static void async_task_finish (AsyncTask* self);
void async_task_parse_stderr_line (AsyncTask* self,
                                   const gchar* err_line);
void async_task_write_stdin (AsyncTask* self,
                             const gchar* line);
static void async_task_real_parse_stdout_line (AsyncTask* self,
                                        const gchar* out_line);
static void async_task_real_parse_stderr_line (AsyncTask* self,
                                        const gchar* err_line);
gint async_task_read_exit_code (AsyncTask* self);
void async_task_finish_task (AsyncTask* self);
static void async_task_real_finish_task (AsyncTask* self);
gchar* tee_jee_file_system_file_parent (const gchar* file_path);
gboolean tee_jee_file_system_file_exists (const gchar* file_path);
gchar* tee_jee_file_system_file_read (const gchar* file_path);
gboolean async_task_is_running (AsyncTask* self);
void async_task_pause (AsyncTask* self);
gint* tee_jee_process_helper_get_process_children (GPid parent_pid,
                                                   gint* result_length1);
gint tee_jee_process_helper_process_pause (GPid procID);
void async_task_resume (AsyncTask* self);
gint tee_jee_process_helper_process_resume (GPid procID);
void async_task_stop (AsyncTask* self,
                      AppStatus status_to_update);
void tee_jee_process_helper_process_quit (GPid process_pid,
                                          gboolean killChildren);
void async_task_set_priority_value (AsyncTask* self,
                                    gint prio);
void tee_jee_process_helper_process_set_priority (GPid procID,
                                                  gint prio);
void async_task_print_app_status (AsyncTask* self);
gchar* async_task_get_stat_time_elapsed (AsyncTask* self);
gulong tee_jee_system_timer_elapsed (GTimer* timer,
                                     gboolean stop);
gchar* tee_jee_misc_format_duration (glong millis);
gchar* async_task_get_stat_time_remaining (AsyncTask* self);
static void async_task_finalize (GObject * obj);
static void _vala_async_task_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

static inline gpointer
async_task_get_instance_private (AsyncTask* self)
{
	return G_STRUCT_MEMBER_P (self, AsyncTask_private_offset);
}

AsyncTask*
async_task_construct (GType object_type)
{
	AsyncTask * self = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	const gchar* _tmp10_;
#line 76 "Utility/AsyncTask.vala"
	self = (AsyncTask*) g_object_new (object_type, NULL);
#line 77 "Utility/AsyncTask.vala"
	_tmp0_ = tee_jee_process_helper_TEMP_DIR;
#line 77 "Utility/AsyncTask.vala"
	_tmp1_ = g_strconcat (_tmp0_, "/", NULL);
#line 77 "Utility/AsyncTask.vala"
	_tmp2_ = _tmp1_;
#line 77 "Utility/AsyncTask.vala"
	_tmp3_ = tee_jee_misc_timestamp_for_path ();
#line 77 "Utility/AsyncTask.vala"
	_tmp4_ = _tmp3_;
#line 77 "Utility/AsyncTask.vala"
	_tmp5_ = g_strconcat (_tmp2_, _tmp4_, NULL);
#line 77 "Utility/AsyncTask.vala"
	_g_free0 (self->working_dir);
#line 77 "Utility/AsyncTask.vala"
	self->working_dir = _tmp5_;
#line 77 "Utility/AsyncTask.vala"
	_g_free0 (_tmp4_);
#line 77 "Utility/AsyncTask.vala"
	_g_free0 (_tmp2_);
#line 78 "Utility/AsyncTask.vala"
	_tmp6_ = self->working_dir;
#line 78 "Utility/AsyncTask.vala"
	_tmp7_ = tee_jee_file_system_path_combine (_tmp6_, "script.sh");
#line 78 "Utility/AsyncTask.vala"
	_g_free0 (self->script_file);
#line 78 "Utility/AsyncTask.vala"
	self->script_file = _tmp7_;
#line 79 "Utility/AsyncTask.vala"
	_tmp8_ = self->working_dir;
#line 79 "Utility/AsyncTask.vala"
	_tmp9_ = tee_jee_file_system_path_combine (_tmp8_, "task.log");
#line 79 "Utility/AsyncTask.vala"
	_g_free0 (self->log_file);
#line 79 "Utility/AsyncTask.vala"
	self->log_file = _tmp9_;
#line 83 "Utility/AsyncTask.vala"
	_tmp10_ = self->working_dir;
#line 83 "Utility/AsyncTask.vala"
	tee_jee_file_system_dir_create (_tmp10_, FALSE);
#line 76 "Utility/AsyncTask.vala"
	return self;
#line 261 "AsyncTask.c"
}

static gpointer
_async_task_read_stdout_gthread_func (gpointer self)
{
	gpointer result;
#line 146 "Utility/AsyncTask.vala"
	async_task_read_stdout ((AsyncTask*) self);
#line 270 "AsyncTask.c"
	result = NULL;
#line 146 "Utility/AsyncTask.vala"
	g_object_unref (self);
#line 146 "Utility/AsyncTask.vala"
	return result;
#line 276 "AsyncTask.c"
}

static gpointer
_async_task_read_stderr_gthread_func (gpointer self)
{
	gpointer result;
#line 154 "Utility/AsyncTask.vala"
	async_task_read_stderr ((AsyncTask*) self);
#line 285 "AsyncTask.c"
	result = NULL;
#line 154 "Utility/AsyncTask.vala"
	g_object_unref (self);
#line 154 "Utility/AsyncTask.vala"
	return result;
#line 291 "AsyncTask.c"
}

gboolean
async_task_begin (AsyncTask* self)
{
	gboolean has_started = FALSE;
	gchar* _tmp0_;
	gchar** spawn_args = NULL;
	gchar** _tmp1_;
	gint spawn_args_length1;
	gint _spawn_args_size_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar** spawn_env = NULL;
	gchar** _tmp5_;
	gchar** _tmp6_;
	gint spawn_env_length1;
	gint _spawn_env_size_;
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
#line 86 "Utility/AsyncTask.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 88 "Utility/AsyncTask.vala"
	self->status = APP_STATUS_RUNNING;
#line 90 "Utility/AsyncTask.vala"
	has_started = TRUE;
#line 91 "Utility/AsyncTask.vala"
	self->is_terminated = FALSE;
#line 92 "Utility/AsyncTask.vala"
	self->priv->finish_called = FALSE;
#line 94 "Utility/AsyncTask.vala"
	self->prg_count = (gint64) 0;
#line 95 "Utility/AsyncTask.vala"
	self->prg_bytes = (gint64) 0;
#line 96 "Utility/AsyncTask.vala"
	_tmp0_ = g_strdup ("");
#line 96 "Utility/AsyncTask.vala"
	_g_free0 (self->error_msg);
#line 96 "Utility/AsyncTask.vala"
	self->error_msg = _tmp0_;
#line 98 "Utility/AsyncTask.vala"
	_tmp1_ = g_new0 (gchar*, 1 + 1);
#line 98 "Utility/AsyncTask.vala"
	spawn_args = _tmp1_;
#line 98 "Utility/AsyncTask.vala"
	spawn_args_length1 = 1;
#line 98 "Utility/AsyncTask.vala"
	_spawn_args_size_ = spawn_args_length1;
#line 99 "Utility/AsyncTask.vala"
	_tmp2_ = spawn_args;
#line 99 "Utility/AsyncTask.vala"
	_tmp2__length1 = spawn_args_length1;
#line 99 "Utility/AsyncTask.vala"
	_tmp3_ = self->script_file;
#line 99 "Utility/AsyncTask.vala"
	_tmp4_ = g_strdup (_tmp3_);
#line 99 "Utility/AsyncTask.vala"
	_g_free0 (_tmp2_[0]);
#line 99 "Utility/AsyncTask.vala"
	_tmp2_[0] = _tmp4_;
#line 101 "Utility/AsyncTask.vala"
	_tmp6_ = _tmp5_ = g_get_environ ();
#line 101 "Utility/AsyncTask.vala"
	spawn_env = _tmp6_;
#line 101 "Utility/AsyncTask.vala"
	spawn_env_length1 = _vala_array_length (_tmp5_);
#line 101 "Utility/AsyncTask.vala"
	_spawn_env_size_ = spawn_env_length1;
#line 362 "AsyncTask.c"
	{
		GTimer* _tmp7_;
		GTimer* _tmp8_;
		const gchar* _tmp9_;
		gchar** _tmp10_;
		gint _tmp10__length1;
		gchar** _tmp11_;
		gint _tmp11__length1;
		GPid _tmp12_ = 0;
		gint _tmp13_ = 0;
		gint _tmp14_ = 0;
		gint _tmp15_ = 0;
		gchar* _tmp16_;
		gchar* _tmp17_;
		GUnixOutputStream* uos_in = NULL;
		GUnixOutputStream* _tmp18_;
		GUnixInputStream* uis_out = NULL;
		GUnixInputStream* _tmp19_;
		GUnixInputStream* uis_err = NULL;
		GUnixInputStream* _tmp20_;
		GUnixOutputStream* _tmp21_;
		GDataOutputStream* _tmp22_;
		GUnixInputStream* _tmp23_;
		GDataInputStream* _tmp24_;
		GUnixInputStream* _tmp25_;
		GDataInputStream* _tmp26_;
		GDataInputStream* _tmp27_;
		GDataInputStream* _tmp28_;
		const gchar* _tmp29_;
		gint _tmp30_;
		gint _tmp31_;
#line 105 "Utility/AsyncTask.vala"
		_tmp7_ = g_timer_new ();
#line 105 "Utility/AsyncTask.vala"
		_g_timer_destroy0 (self->timer);
#line 105 "Utility/AsyncTask.vala"
		self->timer = _tmp7_;
#line 106 "Utility/AsyncTask.vala"
		_tmp8_ = self->timer;
#line 106 "Utility/AsyncTask.vala"
		g_timer_start (_tmp8_);
#line 109 "Utility/AsyncTask.vala"
		_tmp9_ = self->working_dir;
#line 109 "Utility/AsyncTask.vala"
		_tmp10_ = spawn_args;
#line 109 "Utility/AsyncTask.vala"
		_tmp10__length1 = spawn_args_length1;
#line 109 "Utility/AsyncTask.vala"
		_tmp11_ = spawn_env;
#line 109 "Utility/AsyncTask.vala"
		_tmp11__length1 = spawn_env_length1;
#line 109 "Utility/AsyncTask.vala"
		g_spawn_async_with_pipes (_tmp9_, _tmp10_, _tmp11_, G_SPAWN_SEARCH_PATH, NULL, NULL, &_tmp12_, &_tmp13_, &_tmp14_, &_tmp15_, &_inner_error0_);
#line 109 "Utility/AsyncTask.vala"
		self->child_pid = _tmp12_;
#line 109 "Utility/AsyncTask.vala"
		self->priv->input_fd = _tmp13_;
#line 109 "Utility/AsyncTask.vala"
		self->priv->output_fd = _tmp14_;
#line 109 "Utility/AsyncTask.vala"
		self->priv->error_fd = _tmp15_;
#line 109 "Utility/AsyncTask.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 426 "AsyncTask.c"
			goto __catch29_g_error;
		}
#line 120 "Utility/AsyncTask.vala"
		async_task_set_priority (self);
#line 122 "Utility/AsyncTask.vala"
		_tmp16_ = g_strdup_printf ("AsyncTask: child_pid: %d", (gint) self->child_pid);
#line 122 "Utility/AsyncTask.vala"
		_tmp17_ = _tmp16_;
#line 122 "Utility/AsyncTask.vala"
		tee_jee_logging_log_debug (_tmp17_);
#line 122 "Utility/AsyncTask.vala"
		_g_free0 (_tmp17_);
#line 125 "Utility/AsyncTask.vala"
		_tmp18_ = (GUnixOutputStream*) g_unix_output_stream_new (self->priv->input_fd, FALSE);
#line 125 "Utility/AsyncTask.vala"
		uos_in = _tmp18_;
#line 126 "Utility/AsyncTask.vala"
		_tmp19_ = (GUnixInputStream*) g_unix_input_stream_new (self->priv->output_fd, FALSE);
#line 126 "Utility/AsyncTask.vala"
		uis_out = _tmp19_;
#line 127 "Utility/AsyncTask.vala"
		_tmp20_ = (GUnixInputStream*) g_unix_input_stream_new (self->priv->error_fd, FALSE);
#line 127 "Utility/AsyncTask.vala"
		uis_err = _tmp20_;
#line 128 "Utility/AsyncTask.vala"
		_tmp21_ = uos_in;
#line 128 "Utility/AsyncTask.vala"
		_tmp22_ = g_data_output_stream_new ((GOutputStream*) _tmp21_);
#line 128 "Utility/AsyncTask.vala"
		_g_object_unref0 (self->priv->dos_in);
#line 128 "Utility/AsyncTask.vala"
		self->priv->dos_in = _tmp22_;
#line 129 "Utility/AsyncTask.vala"
		_tmp23_ = uis_out;
#line 129 "Utility/AsyncTask.vala"
		_tmp24_ = g_data_input_stream_new ((GInputStream*) _tmp23_);
#line 129 "Utility/AsyncTask.vala"
		_g_object_unref0 (self->priv->dis_out);
#line 129 "Utility/AsyncTask.vala"
		self->priv->dis_out = _tmp24_;
#line 130 "Utility/AsyncTask.vala"
		_tmp25_ = uis_err;
#line 130 "Utility/AsyncTask.vala"
		_tmp26_ = g_data_input_stream_new ((GInputStream*) _tmp25_);
#line 130 "Utility/AsyncTask.vala"
		_g_object_unref0 (self->priv->dis_err);
#line 130 "Utility/AsyncTask.vala"
		self->priv->dis_err = _tmp26_;
#line 131 "Utility/AsyncTask.vala"
		_tmp27_ = self->priv->dis_out;
#line 131 "Utility/AsyncTask.vala"
		g_data_input_stream_set_newline_type (_tmp27_, G_DATA_STREAM_NEWLINE_TYPE_ANY);
#line 132 "Utility/AsyncTask.vala"
		_tmp28_ = self->priv->dis_err;
#line 132 "Utility/AsyncTask.vala"
		g_data_input_stream_set_newline_type (_tmp28_, G_DATA_STREAM_NEWLINE_TYPE_ANY);
#line 135 "Utility/AsyncTask.vala"
		_tmp29_ = self->log_file;
#line 135 "Utility/AsyncTask.vala"
		_tmp30_ = strlen (_tmp29_);
#line 135 "Utility/AsyncTask.vala"
		_tmp31_ = _tmp30_;
#line 135 "Utility/AsyncTask.vala"
		if (_tmp31_ > 0) {
#line 491 "AsyncTask.c"
			GFile* file = NULL;
			const gchar* _tmp32_;
			GFile* _tmp33_;
			GFile* _tmp34_;
			GFileOutputStream* file_stream = NULL;
			GFile* _tmp36_;
			GFileOutputStream* _tmp37_;
			GFileOutputStream* _tmp38_;
			GDataOutputStream* _tmp39_;
#line 136 "Utility/AsyncTask.vala"
			_tmp32_ = self->log_file;
#line 136 "Utility/AsyncTask.vala"
			_tmp33_ = g_file_new_for_path (_tmp32_);
#line 136 "Utility/AsyncTask.vala"
			file = _tmp33_;
#line 137 "Utility/AsyncTask.vala"
			_tmp34_ = file;
#line 137 "Utility/AsyncTask.vala"
			if (g_file_query_exists (_tmp34_, NULL)) {
#line 511 "AsyncTask.c"
				GFile* _tmp35_;
#line 138 "Utility/AsyncTask.vala"
				_tmp35_ = file;
#line 138 "Utility/AsyncTask.vala"
				g_file_delete (_tmp35_, NULL, &_inner_error0_);
#line 138 "Utility/AsyncTask.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 138 "Utility/AsyncTask.vala"
					_g_object_unref0 (file);
#line 138 "Utility/AsyncTask.vala"
					_g_object_unref0 (uis_err);
#line 138 "Utility/AsyncTask.vala"
					_g_object_unref0 (uis_out);
#line 138 "Utility/AsyncTask.vala"
					_g_object_unref0 (uos_in);
#line 527 "AsyncTask.c"
					goto __catch29_g_error;
				}
			}
#line 140 "Utility/AsyncTask.vala"
			_tmp36_ = file;
#line 140 "Utility/AsyncTask.vala"
			_tmp37_ = g_file_create (_tmp36_, G_FILE_CREATE_REPLACE_DESTINATION, NULL, &_inner_error0_);
#line 140 "Utility/AsyncTask.vala"
			file_stream = _tmp37_;
#line 140 "Utility/AsyncTask.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 140 "Utility/AsyncTask.vala"
				_g_object_unref0 (file);
#line 140 "Utility/AsyncTask.vala"
				_g_object_unref0 (uis_err);
#line 140 "Utility/AsyncTask.vala"
				_g_object_unref0 (uis_out);
#line 140 "Utility/AsyncTask.vala"
				_g_object_unref0 (uos_in);
#line 547 "AsyncTask.c"
				goto __catch29_g_error;
			}
#line 141 "Utility/AsyncTask.vala"
			_tmp38_ = file_stream;
#line 141 "Utility/AsyncTask.vala"
			_tmp39_ = g_data_output_stream_new ((GOutputStream*) _tmp38_);
#line 141 "Utility/AsyncTask.vala"
			_g_object_unref0 (self->dos_log);
#line 141 "Utility/AsyncTask.vala"
			self->dos_log = _tmp39_;
#line 135 "Utility/AsyncTask.vala"
			_g_object_unref0 (file_stream);
#line 135 "Utility/AsyncTask.vala"
			_g_object_unref0 (file);
#line 562 "AsyncTask.c"
		}
		{
#line 146 "Utility/AsyncTask.vala"
			g_thread_create (_async_task_read_stdout_gthread_func, g_object_ref (self), TRUE, &_inner_error0_);
#line 146 "Utility/AsyncTask.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 569 "AsyncTask.c"
				goto __catch30_g_error;
			}
		}
		goto __finally30;
		__catch30_g_error:
		{
			GError* e = NULL;
			GError* _tmp40_;
			const gchar* _tmp41_;
#line 144 "Utility/AsyncTask.vala"
			e = _inner_error0_;
#line 144 "Utility/AsyncTask.vala"
			_inner_error0_ = NULL;
#line 148 "Utility/AsyncTask.vala"
			tee_jee_logging_log_error ("AsyncTask.begin():create_thread:read_stdout()", FALSE, FALSE);
#line 149 "Utility/AsyncTask.vala"
			_tmp40_ = e;
#line 149 "Utility/AsyncTask.vala"
			_tmp41_ = _tmp40_->message;
#line 149 "Utility/AsyncTask.vala"
			tee_jee_logging_log_error (_tmp41_, FALSE, FALSE);
#line 144 "Utility/AsyncTask.vala"
			_g_error_free0 (e);
#line 593 "AsyncTask.c"
		}
		__finally30:
#line 144 "Utility/AsyncTask.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 144 "Utility/AsyncTask.vala"
			_g_object_unref0 (uis_err);
#line 144 "Utility/AsyncTask.vala"
			_g_object_unref0 (uis_out);
#line 144 "Utility/AsyncTask.vala"
			_g_object_unref0 (uos_in);
#line 604 "AsyncTask.c"
			goto __catch29_g_error;
		}
		{
#line 154 "Utility/AsyncTask.vala"
			g_thread_create (_async_task_read_stderr_gthread_func, g_object_ref (self), TRUE, &_inner_error0_);
#line 154 "Utility/AsyncTask.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 612 "AsyncTask.c"
				goto __catch31_g_error;
			}
		}
		goto __finally31;
		__catch31_g_error:
		{
			GError* e = NULL;
			GError* _tmp42_;
			const gchar* _tmp43_;
#line 152 "Utility/AsyncTask.vala"
			e = _inner_error0_;
#line 152 "Utility/AsyncTask.vala"
			_inner_error0_ = NULL;
#line 156 "Utility/AsyncTask.vala"
			tee_jee_logging_log_error ("AsyncTask.begin():create_thread:read_stderr()", FALSE, FALSE);
#line 157 "Utility/AsyncTask.vala"
			_tmp42_ = e;
#line 157 "Utility/AsyncTask.vala"
			_tmp43_ = _tmp42_->message;
#line 157 "Utility/AsyncTask.vala"
			tee_jee_logging_log_error (_tmp43_, FALSE, FALSE);
#line 152 "Utility/AsyncTask.vala"
			_g_error_free0 (e);
#line 636 "AsyncTask.c"
		}
		__finally31:
#line 152 "Utility/AsyncTask.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 152 "Utility/AsyncTask.vala"
			_g_object_unref0 (uis_err);
#line 152 "Utility/AsyncTask.vala"
			_g_object_unref0 (uis_out);
#line 152 "Utility/AsyncTask.vala"
			_g_object_unref0 (uos_in);
#line 647 "AsyncTask.c"
			goto __catch29_g_error;
		}
#line 103 "Utility/AsyncTask.vala"
		_g_object_unref0 (uis_err);
#line 103 "Utility/AsyncTask.vala"
		_g_object_unref0 (uis_out);
#line 103 "Utility/AsyncTask.vala"
		_g_object_unref0 (uos_in);
#line 656 "AsyncTask.c"
	}
	goto __finally29;
	__catch29_g_error:
	{
		GError* e = NULL;
		GError* _tmp44_;
		const gchar* _tmp45_;
#line 103 "Utility/AsyncTask.vala"
		e = _inner_error0_;
#line 103 "Utility/AsyncTask.vala"
		_inner_error0_ = NULL;
#line 161 "Utility/AsyncTask.vala"
		tee_jee_logging_log_error ("AsyncTask.begin()", FALSE, FALSE);
#line 162 "Utility/AsyncTask.vala"
		_tmp44_ = e;
#line 162 "Utility/AsyncTask.vala"
		_tmp45_ = _tmp44_->message;
#line 162 "Utility/AsyncTask.vala"
		tee_jee_logging_log_error (_tmp45_, FALSE, FALSE);
#line 163 "Utility/AsyncTask.vala"
		has_started = FALSE;
#line 103 "Utility/AsyncTask.vala"
		_g_error_free0 (e);
#line 680 "AsyncTask.c"
	}
	__finally29:
#line 103 "Utility/AsyncTask.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 685 "AsyncTask.c"
		gboolean _tmp46_ = FALSE;
#line 103 "Utility/AsyncTask.vala"
		spawn_env = (_vala_array_free (spawn_env, spawn_env_length1, (GDestroyNotify) g_free), NULL);
#line 103 "Utility/AsyncTask.vala"
		spawn_args = (_vala_array_free (spawn_args, spawn_args_length1, (GDestroyNotify) g_free), NULL);
#line 103 "Utility/AsyncTask.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 103 "Utility/AsyncTask.vala"
		g_clear_error (&_inner_error0_);
#line 103 "Utility/AsyncTask.vala"
		return _tmp46_;
#line 697 "AsyncTask.c"
	}
#line 167 "Utility/AsyncTask.vala"
	result = has_started;
#line 167 "Utility/AsyncTask.vala"
	spawn_env = (_vala_array_free (spawn_env, spawn_env_length1, (GDestroyNotify) g_free), NULL);
#line 167 "Utility/AsyncTask.vala"
	spawn_args = (_vala_array_free (spawn_args, spawn_args_length1, (GDestroyNotify) g_free), NULL);
#line 167 "Utility/AsyncTask.vala"
	return result;
#line 707 "AsyncTask.c"
}

static void
async_task_read_stdout (AsyncTask* self)
{
	GError* _inner_error0_ = NULL;
#line 170 "Utility/AsyncTask.vala"
	g_return_if_fail (self != NULL);
#line 716 "AsyncTask.c"
	{
		gchar* _tmp0_ = NULL;
		GDataInputStream* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gboolean _tmp15_ = FALSE;
		GDataInputStream* _tmp16_;
		gboolean _tmp19_ = FALSE;
#line 172 "Utility/AsyncTask.vala"
		self->priv->stdout_is_open = TRUE;
#line 174 "Utility/AsyncTask.vala"
		_tmp1_ = self->priv->dis_out;
#line 174 "Utility/AsyncTask.vala"
		_tmp2_ = g_data_input_stream_read_line (_tmp1_, NULL, NULL, &_inner_error0_);
#line 174 "Utility/AsyncTask.vala"
		_tmp0_ = _tmp2_;
#line 174 "Utility/AsyncTask.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 735 "AsyncTask.c"
			goto __catch32_g_error;
		}
#line 174 "Utility/AsyncTask.vala"
		_tmp3_ = _tmp0_;
#line 174 "Utility/AsyncTask.vala"
		_tmp0_ = NULL;
#line 174 "Utility/AsyncTask.vala"
		_g_free0 (self->priv->out_line);
#line 174 "Utility/AsyncTask.vala"
		self->priv->out_line = _tmp3_;
#line 175 "Utility/AsyncTask.vala"
		while (TRUE) {
#line 748 "AsyncTask.c"
			const gchar* _tmp4_;
			gboolean _tmp5_ = FALSE;
			gchar* _tmp11_ = NULL;
			GDataInputStream* _tmp12_;
			gchar* _tmp13_;
			gchar* _tmp14_;
#line 175 "Utility/AsyncTask.vala"
			_tmp4_ = self->priv->out_line;
#line 175 "Utility/AsyncTask.vala"
			if (!(_tmp4_ != NULL)) {
#line 175 "Utility/AsyncTask.vala"
				break;
#line 761 "AsyncTask.c"
			}
#line 177 "Utility/AsyncTask.vala"
			if (!self->is_terminated) {
#line 765 "AsyncTask.c"
				const gchar* _tmp6_;
				gint _tmp7_;
				gint _tmp8_;
#line 177 "Utility/AsyncTask.vala"
				_tmp6_ = self->priv->out_line;
#line 177 "Utility/AsyncTask.vala"
				_tmp7_ = strlen (_tmp6_);
#line 177 "Utility/AsyncTask.vala"
				_tmp8_ = _tmp7_;
#line 177 "Utility/AsyncTask.vala"
				_tmp5_ = _tmp8_ > 0;
#line 777 "AsyncTask.c"
			} else {
#line 177 "Utility/AsyncTask.vala"
				_tmp5_ = FALSE;
#line 781 "AsyncTask.c"
			}
#line 177 "Utility/AsyncTask.vala"
			if (_tmp5_) {
#line 785 "AsyncTask.c"
				const gchar* _tmp9_;
				const gchar* _tmp10_;
#line 178 "Utility/AsyncTask.vala"
				_tmp9_ = self->priv->out_line;
#line 178 "Utility/AsyncTask.vala"
				async_task_parse_stdout_line (self, _tmp9_);
#line 179 "Utility/AsyncTask.vala"
				_tmp10_ = self->priv->out_line;
#line 179 "Utility/AsyncTask.vala"
				g_signal_emit (self, async_task_signals[ASYNC_TASK_STDOUT_LINE_READ_SIGNAL], 0, _tmp10_);
#line 796 "AsyncTask.c"
			}
#line 181 "Utility/AsyncTask.vala"
			_tmp12_ = self->priv->dis_out;
#line 181 "Utility/AsyncTask.vala"
			_tmp13_ = g_data_input_stream_read_line (_tmp12_, NULL, NULL, &_inner_error0_);
#line 181 "Utility/AsyncTask.vala"
			_tmp11_ = _tmp13_;
#line 181 "Utility/AsyncTask.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 181 "Utility/AsyncTask.vala"
				_g_free0 (_tmp0_);
#line 808 "AsyncTask.c"
				goto __catch32_g_error;
			}
#line 181 "Utility/AsyncTask.vala"
			_tmp14_ = _tmp11_;
#line 181 "Utility/AsyncTask.vala"
			_tmp11_ = NULL;
#line 181 "Utility/AsyncTask.vala"
			_g_free0 (self->priv->out_line);
#line 181 "Utility/AsyncTask.vala"
			self->priv->out_line = _tmp14_;
#line 175 "Utility/AsyncTask.vala"
			_g_free0 (_tmp11_);
#line 821 "AsyncTask.c"
		}
#line 184 "Utility/AsyncTask.vala"
		self->priv->stdout_is_open = FALSE;
#line 187 "Utility/AsyncTask.vala"
		_tmp16_ = self->priv->dis_out;
#line 187 "Utility/AsyncTask.vala"
		if (_tmp16_ != NULL) {
#line 829 "AsyncTask.c"
			GDataInputStream* _tmp17_;
#line 187 "Utility/AsyncTask.vala"
			_tmp17_ = self->priv->dis_out;
#line 187 "Utility/AsyncTask.vala"
			_tmp15_ = !g_input_stream_is_closed ((GInputStream*) _tmp17_);
#line 835 "AsyncTask.c"
		} else {
#line 187 "Utility/AsyncTask.vala"
			_tmp15_ = FALSE;
#line 839 "AsyncTask.c"
		}
#line 187 "Utility/AsyncTask.vala"
		if (_tmp15_) {
#line 843 "AsyncTask.c"
			GDataInputStream* _tmp18_;
#line 188 "Utility/AsyncTask.vala"
			_tmp18_ = self->priv->dis_out;
#line 188 "Utility/AsyncTask.vala"
			g_input_stream_close ((GInputStream*) _tmp18_, NULL, &_inner_error0_);
#line 188 "Utility/AsyncTask.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 188 "Utility/AsyncTask.vala"
				_g_free0 (_tmp0_);
#line 853 "AsyncTask.c"
				goto __catch32_g_error;
			}
		}
#line 191 "Utility/AsyncTask.vala"
		_g_object_unref0 (self->priv->dis_out);
#line 191 "Utility/AsyncTask.vala"
		self->priv->dis_out = NULL;
#line 192 "Utility/AsyncTask.vala"
		close (self->priv->output_fd);
#line 195 "Utility/AsyncTask.vala"
		if (!self->priv->stdout_is_open) {
#line 195 "Utility/AsyncTask.vala"
			_tmp19_ = !self->priv->stderr_is_open;
#line 867 "AsyncTask.c"
		} else {
#line 195 "Utility/AsyncTask.vala"
			_tmp19_ = FALSE;
#line 871 "AsyncTask.c"
		}
#line 195 "Utility/AsyncTask.vala"
		if (_tmp19_) {
#line 196 "Utility/AsyncTask.vala"
			async_task_finish (self);
#line 877 "AsyncTask.c"
		}
#line 171 "Utility/AsyncTask.vala"
		_g_free0 (_tmp0_);
#line 881 "AsyncTask.c"
	}
	goto __finally32;
	__catch32_g_error:
	{
		GError* e = NULL;
		GError* _tmp20_;
		const gchar* _tmp21_;
#line 171 "Utility/AsyncTask.vala"
		e = _inner_error0_;
#line 171 "Utility/AsyncTask.vala"
		_inner_error0_ = NULL;
#line 200 "Utility/AsyncTask.vala"
		tee_jee_logging_log_error ("AsyncTask.read_stdout()", FALSE, FALSE);
#line 201 "Utility/AsyncTask.vala"
		_tmp20_ = e;
#line 201 "Utility/AsyncTask.vala"
		_tmp21_ = _tmp20_->message;
#line 201 "Utility/AsyncTask.vala"
		tee_jee_logging_log_error (_tmp21_, FALSE, FALSE);
#line 171 "Utility/AsyncTask.vala"
		_g_error_free0 (e);
#line 903 "AsyncTask.c"
	}
	__finally32:
#line 171 "Utility/AsyncTask.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 171 "Utility/AsyncTask.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 171 "Utility/AsyncTask.vala"
		g_clear_error (&_inner_error0_);
#line 171 "Utility/AsyncTask.vala"
		return;
#line 914 "AsyncTask.c"
	}
}

static void
async_task_read_stderr (AsyncTask* self)
{
	GError* _inner_error0_ = NULL;
#line 205 "Utility/AsyncTask.vala"
	g_return_if_fail (self != NULL);
#line 924 "AsyncTask.c"
	{
		gchar* _tmp0_ = NULL;
		GDataInputStream* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gboolean _tmp20_ = FALSE;
		GDataInputStream* _tmp21_;
		gboolean _tmp24_ = FALSE;
#line 207 "Utility/AsyncTask.vala"
		self->priv->stderr_is_open = TRUE;
#line 209 "Utility/AsyncTask.vala"
		_tmp1_ = self->priv->dis_err;
#line 209 "Utility/AsyncTask.vala"
		_tmp2_ = g_data_input_stream_read_line (_tmp1_, NULL, NULL, &_inner_error0_);
#line 209 "Utility/AsyncTask.vala"
		_tmp0_ = _tmp2_;
#line 209 "Utility/AsyncTask.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 943 "AsyncTask.c"
			goto __catch33_g_error;
		}
#line 209 "Utility/AsyncTask.vala"
		_tmp3_ = _tmp0_;
#line 209 "Utility/AsyncTask.vala"
		_tmp0_ = NULL;
#line 209 "Utility/AsyncTask.vala"
		_g_free0 (self->priv->err_line);
#line 209 "Utility/AsyncTask.vala"
		self->priv->err_line = _tmp3_;
#line 210 "Utility/AsyncTask.vala"
		while (TRUE) {
#line 956 "AsyncTask.c"
			const gchar* _tmp4_;
			gboolean _tmp5_ = FALSE;
			gchar* _tmp16_ = NULL;
			GDataInputStream* _tmp17_;
			gchar* _tmp18_;
			gchar* _tmp19_;
#line 210 "Utility/AsyncTask.vala"
			_tmp4_ = self->priv->err_line;
#line 210 "Utility/AsyncTask.vala"
			if (!(_tmp4_ != NULL)) {
#line 210 "Utility/AsyncTask.vala"
				break;
#line 969 "AsyncTask.c"
			}
#line 211 "Utility/AsyncTask.vala"
			if (!self->is_terminated) {
#line 973 "AsyncTask.c"
				const gchar* _tmp6_;
				gint _tmp7_;
				gint _tmp8_;
#line 211 "Utility/AsyncTask.vala"
				_tmp6_ = self->priv->err_line;
#line 211 "Utility/AsyncTask.vala"
				_tmp7_ = strlen (_tmp6_);
#line 211 "Utility/AsyncTask.vala"
				_tmp8_ = _tmp7_;
#line 211 "Utility/AsyncTask.vala"
				_tmp5_ = _tmp8_ > 0;
#line 985 "AsyncTask.c"
			} else {
#line 211 "Utility/AsyncTask.vala"
				_tmp5_ = FALSE;
#line 989 "AsyncTask.c"
			}
#line 211 "Utility/AsyncTask.vala"
			if (_tmp5_) {
#line 993 "AsyncTask.c"
				const gchar* _tmp9_;
				const gchar* _tmp10_;
				gchar* _tmp11_;
				gchar* _tmp12_;
				gchar* _tmp13_;
				const gchar* _tmp14_;
				const gchar* _tmp15_;
#line 212 "Utility/AsyncTask.vala"
				_tmp9_ = self->error_msg;
#line 212 "Utility/AsyncTask.vala"
				_tmp10_ = self->priv->err_line;
#line 212 "Utility/AsyncTask.vala"
				_tmp11_ = g_strdup_printf ("%s\n", _tmp10_);
#line 212 "Utility/AsyncTask.vala"
				_tmp12_ = _tmp11_;
#line 212 "Utility/AsyncTask.vala"
				_tmp13_ = g_strconcat (_tmp9_, _tmp12_, NULL);
#line 212 "Utility/AsyncTask.vala"
				_g_free0 (self->error_msg);
#line 212 "Utility/AsyncTask.vala"
				self->error_msg = _tmp13_;
#line 212 "Utility/AsyncTask.vala"
				_g_free0 (_tmp12_);
#line 214 "Utility/AsyncTask.vala"
				_tmp14_ = self->priv->err_line;
#line 214 "Utility/AsyncTask.vala"
				async_task_parse_stderr_line (self, _tmp14_);
#line 215 "Utility/AsyncTask.vala"
				_tmp15_ = self->priv->err_line;
#line 215 "Utility/AsyncTask.vala"
				g_signal_emit (self, async_task_signals[ASYNC_TASK_STDERR_LINE_READ_SIGNAL], 0, _tmp15_);
#line 1025 "AsyncTask.c"
			}
#line 217 "Utility/AsyncTask.vala"
			_tmp17_ = self->priv->dis_err;
#line 217 "Utility/AsyncTask.vala"
			_tmp18_ = g_data_input_stream_read_line (_tmp17_, NULL, NULL, &_inner_error0_);
#line 217 "Utility/AsyncTask.vala"
			_tmp16_ = _tmp18_;
#line 217 "Utility/AsyncTask.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 217 "Utility/AsyncTask.vala"
				_g_free0 (_tmp0_);
#line 1037 "AsyncTask.c"
				goto __catch33_g_error;
			}
#line 217 "Utility/AsyncTask.vala"
			_tmp19_ = _tmp16_;
#line 217 "Utility/AsyncTask.vala"
			_tmp16_ = NULL;
#line 217 "Utility/AsyncTask.vala"
			_g_free0 (self->priv->err_line);
#line 217 "Utility/AsyncTask.vala"
			self->priv->err_line = _tmp19_;
#line 210 "Utility/AsyncTask.vala"
			_g_free0 (_tmp16_);
#line 1050 "AsyncTask.c"
		}
#line 220 "Utility/AsyncTask.vala"
		self->priv->stderr_is_open = FALSE;
#line 223 "Utility/AsyncTask.vala"
		_tmp21_ = self->priv->dis_err;
#line 223 "Utility/AsyncTask.vala"
		if (_tmp21_ != NULL) {
#line 1058 "AsyncTask.c"
			GDataInputStream* _tmp22_;
#line 223 "Utility/AsyncTask.vala"
			_tmp22_ = self->priv->dis_err;
#line 223 "Utility/AsyncTask.vala"
			_tmp20_ = !g_input_stream_is_closed ((GInputStream*) _tmp22_);
#line 1064 "AsyncTask.c"
		} else {
#line 223 "Utility/AsyncTask.vala"
			_tmp20_ = FALSE;
#line 1068 "AsyncTask.c"
		}
#line 223 "Utility/AsyncTask.vala"
		if (_tmp20_) {
#line 1072 "AsyncTask.c"
			GDataInputStream* _tmp23_;
#line 224 "Utility/AsyncTask.vala"
			_tmp23_ = self->priv->dis_err;
#line 224 "Utility/AsyncTask.vala"
			g_input_stream_close ((GInputStream*) _tmp23_, NULL, &_inner_error0_);
#line 224 "Utility/AsyncTask.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 224 "Utility/AsyncTask.vala"
				_g_free0 (_tmp0_);
#line 1082 "AsyncTask.c"
				goto __catch33_g_error;
			}
		}
#line 227 "Utility/AsyncTask.vala"
		_g_object_unref0 (self->priv->dis_err);
#line 227 "Utility/AsyncTask.vala"
		self->priv->dis_err = NULL;
#line 228 "Utility/AsyncTask.vala"
		close (self->priv->error_fd);
#line 231 "Utility/AsyncTask.vala"
		if (!self->priv->stdout_is_open) {
#line 231 "Utility/AsyncTask.vala"
			_tmp24_ = !self->priv->stderr_is_open;
#line 1096 "AsyncTask.c"
		} else {
#line 231 "Utility/AsyncTask.vala"
			_tmp24_ = FALSE;
#line 1100 "AsyncTask.c"
		}
#line 231 "Utility/AsyncTask.vala"
		if (_tmp24_) {
#line 232 "Utility/AsyncTask.vala"
			async_task_finish (self);
#line 1106 "AsyncTask.c"
		}
#line 206 "Utility/AsyncTask.vala"
		_g_free0 (_tmp0_);
#line 1110 "AsyncTask.c"
	}
	goto __finally33;
	__catch33_g_error:
	{
		GError* e = NULL;
		GError* _tmp25_;
		const gchar* _tmp26_;
#line 206 "Utility/AsyncTask.vala"
		e = _inner_error0_;
#line 206 "Utility/AsyncTask.vala"
		_inner_error0_ = NULL;
#line 236 "Utility/AsyncTask.vala"
		tee_jee_logging_log_error ("AsyncTask.read_stderr()", FALSE, FALSE);
#line 237 "Utility/AsyncTask.vala"
		_tmp25_ = e;
#line 237 "Utility/AsyncTask.vala"
		_tmp26_ = _tmp25_->message;
#line 237 "Utility/AsyncTask.vala"
		tee_jee_logging_log_error (_tmp26_, FALSE, FALSE);
#line 206 "Utility/AsyncTask.vala"
		_g_error_free0 (e);
#line 1132 "AsyncTask.c"
	}
	__finally33:
#line 206 "Utility/AsyncTask.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 206 "Utility/AsyncTask.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 206 "Utility/AsyncTask.vala"
		g_clear_error (&_inner_error0_);
#line 206 "Utility/AsyncTask.vala"
		return;
#line 1143 "AsyncTask.c"
	}
}

void
async_task_write_stdin (AsyncTask* self,
                        const gchar* line)
{
	GError* _inner_error0_ = NULL;
#line 241 "Utility/AsyncTask.vala"
	g_return_if_fail (self != NULL);
#line 241 "Utility/AsyncTask.vala"
	g_return_if_fail (line != NULL);
#line 1156 "AsyncTask.c"
	{
		AppStatus _tmp0_;
#line 243 "Utility/AsyncTask.vala"
		_tmp0_ = self->status;
#line 243 "Utility/AsyncTask.vala"
		if (_tmp0_ == APP_STATUS_RUNNING) {
#line 1163 "AsyncTask.c"
			GDataOutputStream* _tmp1_;
			gchar* _tmp2_;
			gchar* _tmp3_;
#line 244 "Utility/AsyncTask.vala"
			_tmp1_ = self->priv->dos_in;
#line 244 "Utility/AsyncTask.vala"
			_tmp2_ = g_strconcat (line, "\n", NULL);
#line 244 "Utility/AsyncTask.vala"
			_tmp3_ = _tmp2_;
#line 244 "Utility/AsyncTask.vala"
			g_data_output_stream_put_string (_tmp1_, _tmp3_, NULL, &_inner_error0_);
#line 244 "Utility/AsyncTask.vala"
			_g_free0 (_tmp3_);
#line 244 "Utility/AsyncTask.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1179 "AsyncTask.c"
				goto __catch34_g_error;
			}
		} else {
#line 247 "Utility/AsyncTask.vala"
			tee_jee_logging_log_error ("AsyncTask.write_stdin(): NOT RUNNING", FALSE, FALSE);
#line 1185 "AsyncTask.c"
		}
	}
	goto __finally34;
	__catch34_g_error:
	{
		GError* e = NULL;
		gchar* _tmp4_;
		gchar* _tmp5_;
		GError* _tmp6_;
		const gchar* _tmp7_;
#line 242 "Utility/AsyncTask.vala"
		e = _inner_error0_;
#line 242 "Utility/AsyncTask.vala"
		_inner_error0_ = NULL;
#line 251 "Utility/AsyncTask.vala"
		_tmp4_ = g_strdup_printf ("AsyncTask.write_stdin(): %s", line);
#line 251 "Utility/AsyncTask.vala"
		_tmp5_ = _tmp4_;
#line 251 "Utility/AsyncTask.vala"
		tee_jee_logging_log_error (_tmp5_, FALSE, FALSE);
#line 251 "Utility/AsyncTask.vala"
		_g_free0 (_tmp5_);
#line 252 "Utility/AsyncTask.vala"
		_tmp6_ = e;
#line 252 "Utility/AsyncTask.vala"
		_tmp7_ = _tmp6_->message;
#line 252 "Utility/AsyncTask.vala"
		tee_jee_logging_log_error (_tmp7_, FALSE, FALSE);
#line 242 "Utility/AsyncTask.vala"
		_g_error_free0 (e);
#line 1216 "AsyncTask.c"
	}
	__finally34:
#line 242 "Utility/AsyncTask.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 242 "Utility/AsyncTask.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 242 "Utility/AsyncTask.vala"
		g_clear_error (&_inner_error0_);
#line 242 "Utility/AsyncTask.vala"
		return;
#line 1227 "AsyncTask.c"
	}
}

static void
async_task_real_parse_stdout_line (AsyncTask* self,
                                   const gchar* out_line)
{
#line 256 "Utility/AsyncTask.vala"
	g_critical ("Type `%s' does not implement abstract method `async_task_parse_stdout_line'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 256 "Utility/AsyncTask.vala"
	return;
#line 1239 "AsyncTask.c"
}

void
async_task_parse_stdout_line (AsyncTask* self,
                              const gchar* out_line)
{
#line 256 "Utility/AsyncTask.vala"
	g_return_if_fail (self != NULL);
#line 256 "Utility/AsyncTask.vala"
	ASYNC_TASK_GET_CLASS (self)->parse_stdout_line (self, out_line);
#line 1250 "AsyncTask.c"
}

static void
async_task_real_parse_stderr_line (AsyncTask* self,
                                   const gchar* err_line)
{
#line 258 "Utility/AsyncTask.vala"
	g_critical ("Type `%s' does not implement abstract method `async_task_parse_stderr_line'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 258 "Utility/AsyncTask.vala"
	return;
#line 1261 "AsyncTask.c"
}

void
async_task_parse_stderr_line (AsyncTask* self,
                              const gchar* err_line)
{
#line 258 "Utility/AsyncTask.vala"
	g_return_if_fail (self != NULL);
#line 258 "Utility/AsyncTask.vala"
	ASYNC_TASK_GET_CLASS (self)->parse_stderr_line (self, err_line);
#line 1272 "AsyncTask.c"
}

static void
async_task_finish (AsyncTask* self)
{
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	GTimer* _tmp15_;
	gboolean _tmp16_ = FALSE;
	AppStatus _tmp17_;
	GError* _inner_error0_ = NULL;
#line 260 "Utility/AsyncTask.vala"
	g_return_if_fail (self != NULL);
#line 262 "Utility/AsyncTask.vala"
	if (self->priv->finish_called) {
#line 262 "Utility/AsyncTask.vala"
		return;
#line 1291 "AsyncTask.c"
	}
#line 263 "Utility/AsyncTask.vala"
	self->priv->finish_called = TRUE;
#line 265 "Utility/AsyncTask.vala"
	tee_jee_logging_log_debug ("AsyncTask: finish(): enter");
#line 1297 "AsyncTask.c"
	{
		gboolean _tmp0_ = FALSE;
		gboolean _tmp1_ = FALSE;
		GDataOutputStream* _tmp2_;
#line 269 "Utility/AsyncTask.vala"
		_tmp2_ = self->priv->dos_in;
#line 269 "Utility/AsyncTask.vala"
		if (_tmp2_ != NULL) {
#line 1306 "AsyncTask.c"
			GDataOutputStream* _tmp3_;
#line 269 "Utility/AsyncTask.vala"
			_tmp3_ = self->priv->dos_in;
#line 269 "Utility/AsyncTask.vala"
			_tmp1_ = !g_output_stream_is_closed ((GOutputStream*) _tmp3_);
#line 1312 "AsyncTask.c"
		} else {
#line 269 "Utility/AsyncTask.vala"
			_tmp1_ = FALSE;
#line 1316 "AsyncTask.c"
		}
#line 269 "Utility/AsyncTask.vala"
		if (_tmp1_) {
#line 1320 "AsyncTask.c"
			GDataOutputStream* _tmp4_;
#line 269 "Utility/AsyncTask.vala"
			_tmp4_ = self->priv->dos_in;
#line 269 "Utility/AsyncTask.vala"
			_tmp0_ = !g_output_stream_is_closing ((GOutputStream*) _tmp4_);
#line 1326 "AsyncTask.c"
		} else {
#line 269 "Utility/AsyncTask.vala"
			_tmp0_ = FALSE;
#line 1330 "AsyncTask.c"
		}
#line 269 "Utility/AsyncTask.vala"
		if (_tmp0_) {
#line 1334 "AsyncTask.c"
			GDataOutputStream* _tmp5_;
#line 270 "Utility/AsyncTask.vala"
			_tmp5_ = self->priv->dos_in;
#line 270 "Utility/AsyncTask.vala"
			g_output_stream_close ((GOutputStream*) _tmp5_, NULL, &_inner_error0_);
#line 270 "Utility/AsyncTask.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1342 "AsyncTask.c"
				goto __catch35_g_error;
			}
		}
	}
	goto __finally35;
	__catch35_g_error:
	{
		GError* e = NULL;
#line 268 "Utility/AsyncTask.vala"
		e = _inner_error0_;
#line 268 "Utility/AsyncTask.vala"
		_inner_error0_ = NULL;
#line 268 "Utility/AsyncTask.vala"
		_g_error_free0 (e);
#line 1357 "AsyncTask.c"
	}
	__finally35:
#line 268 "Utility/AsyncTask.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 268 "Utility/AsyncTask.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 268 "Utility/AsyncTask.vala"
		g_clear_error (&_inner_error0_);
#line 268 "Utility/AsyncTask.vala"
		return;
#line 1368 "AsyncTask.c"
	}
#line 279 "Utility/AsyncTask.vala"
	_g_object_unref0 (self->priv->dos_in);
#line 279 "Utility/AsyncTask.vala"
	self->priv->dos_in = NULL;
#line 280 "Utility/AsyncTask.vala"
	close (self->priv->input_fd);
#line 283 "Utility/AsyncTask.vala"
	g_spawn_close_pid (self->child_pid);
#line 1378 "AsyncTask.c"
	{
		gboolean _tmp6_ = FALSE;
		gboolean _tmp7_ = FALSE;
		GDataOutputStream* _tmp8_;
#line 287 "Utility/AsyncTask.vala"
		_tmp8_ = self->dos_log;
#line 287 "Utility/AsyncTask.vala"
		if (_tmp8_ != NULL) {
#line 1387 "AsyncTask.c"
			GDataOutputStream* _tmp9_;
#line 287 "Utility/AsyncTask.vala"
			_tmp9_ = self->dos_log;
#line 287 "Utility/AsyncTask.vala"
			_tmp7_ = !g_output_stream_is_closed ((GOutputStream*) _tmp9_);
#line 1393 "AsyncTask.c"
		} else {
#line 287 "Utility/AsyncTask.vala"
			_tmp7_ = FALSE;
#line 1397 "AsyncTask.c"
		}
#line 287 "Utility/AsyncTask.vala"
		if (_tmp7_) {
#line 1401 "AsyncTask.c"
			GDataOutputStream* _tmp10_;
#line 287 "Utility/AsyncTask.vala"
			_tmp10_ = self->dos_log;
#line 287 "Utility/AsyncTask.vala"
			_tmp6_ = !g_output_stream_is_closing ((GOutputStream*) _tmp10_);
#line 1407 "AsyncTask.c"
		} else {
#line 287 "Utility/AsyncTask.vala"
			_tmp6_ = FALSE;
#line 1411 "AsyncTask.c"
		}
#line 287 "Utility/AsyncTask.vala"
		if (_tmp6_) {
#line 1415 "AsyncTask.c"
			GDataOutputStream* _tmp11_;
#line 288 "Utility/AsyncTask.vala"
			_tmp11_ = self->dos_log;
#line 288 "Utility/AsyncTask.vala"
			g_output_stream_close ((GOutputStream*) _tmp11_, NULL, &_inner_error0_);
#line 288 "Utility/AsyncTask.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1423 "AsyncTask.c"
				goto __catch36_g_error;
			}
		}
#line 290 "Utility/AsyncTask.vala"
		_g_object_unref0 (self->dos_log);
#line 290 "Utility/AsyncTask.vala"
		self->dos_log = NULL;
#line 1431 "AsyncTask.c"
	}
	goto __finally36;
	__catch36_g_error:
	{
		GError* e = NULL;
#line 285 "Utility/AsyncTask.vala"
		e = _inner_error0_;
#line 285 "Utility/AsyncTask.vala"
		_inner_error0_ = NULL;
#line 285 "Utility/AsyncTask.vala"
		_g_error_free0 (e);
#line 1443 "AsyncTask.c"
	}
	__finally36:
#line 285 "Utility/AsyncTask.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 285 "Utility/AsyncTask.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 285 "Utility/AsyncTask.vala"
		g_clear_error (&_inner_error0_);
#line 285 "Utility/AsyncTask.vala"
		return;
#line 1454 "AsyncTask.c"
	}
#line 298 "Utility/AsyncTask.vala"
	async_task_read_exit_code (self);
#line 300 "Utility/AsyncTask.vala"
	_tmp12_ = g_strdup ("");
#line 300 "Utility/AsyncTask.vala"
	_g_free0 (self->status_line);
#line 300 "Utility/AsyncTask.vala"
	self->status_line = _tmp12_;
#line 301 "Utility/AsyncTask.vala"
	_tmp13_ = g_strdup ("");
#line 301 "Utility/AsyncTask.vala"
	_g_free0 (self->priv->err_line);
#line 301 "Utility/AsyncTask.vala"
	self->priv->err_line = _tmp13_;
#line 302 "Utility/AsyncTask.vala"
	_tmp14_ = g_strdup ("");
#line 302 "Utility/AsyncTask.vala"
	_g_free0 (self->priv->out_line);
#line 302 "Utility/AsyncTask.vala"
	self->priv->out_line = _tmp14_;
#line 304 "Utility/AsyncTask.vala"
	_tmp15_ = self->timer;
#line 304 "Utility/AsyncTask.vala"
	g_timer_stop (_tmp15_);
#line 306 "Utility/AsyncTask.vala"
	async_task_finish_task (self);
#line 308 "Utility/AsyncTask.vala"
	_tmp17_ = self->status;
#line 308 "Utility/AsyncTask.vala"
	if (_tmp17_ != APP_STATUS_CANCELLED) {
#line 1486 "AsyncTask.c"
		AppStatus _tmp18_;
#line 308 "Utility/AsyncTask.vala"
		_tmp18_ = self->status;
#line 308 "Utility/AsyncTask.vala"
		_tmp16_ = _tmp18_ != APP_STATUS_PASSWORD_REQUIRED;
#line 1492 "AsyncTask.c"
	} else {
#line 308 "Utility/AsyncTask.vala"
		_tmp16_ = FALSE;
#line 1496 "AsyncTask.c"
	}
#line 308 "Utility/AsyncTask.vala"
	if (_tmp16_) {
#line 309 "Utility/AsyncTask.vala"
		self->status = APP_STATUS_FINISHED;
#line 1502 "AsyncTask.c"
	}
#line 314 "Utility/AsyncTask.vala"
	g_signal_emit (self, async_task_signals[ASYNC_TASK_TASK_COMPLETE_SIGNAL], 0);
#line 1506 "AsyncTask.c"
}

static void
async_task_real_finish_task (AsyncTask* self)
{
#line 317 "Utility/AsyncTask.vala"
	g_critical ("Type `%s' does not implement abstract method `async_task_finish_task'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 317 "Utility/AsyncTask.vala"
	return;
#line 1516 "AsyncTask.c"
}

void
async_task_finish_task (AsyncTask* self)
{
#line 317 "Utility/AsyncTask.vala"
	g_return_if_fail (self != NULL);
#line 317 "Utility/AsyncTask.vala"
	ASYNC_TASK_GET_CLASS (self)->finish_task (self);
#line 1526 "AsyncTask.c"
}

gint
async_task_read_exit_code (AsyncTask* self)
{
	gchar* path = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gint result = 0;
#line 319 "Utility/AsyncTask.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 320 "Utility/AsyncTask.vala"
	self->exit_code = -1;
#line 321 "Utility/AsyncTask.vala"
	_tmp0_ = self->script_file;
#line 321 "Utility/AsyncTask.vala"
	_tmp1_ = tee_jee_file_system_file_parent (_tmp0_);
#line 321 "Utility/AsyncTask.vala"
	_tmp2_ = _tmp1_;
#line 321 "Utility/AsyncTask.vala"
	_tmp3_ = g_strconcat (_tmp2_, "/status", NULL);
#line 321 "Utility/AsyncTask.vala"
	_tmp4_ = _tmp3_;
#line 321 "Utility/AsyncTask.vala"
	_g_free0 (_tmp2_);
#line 321 "Utility/AsyncTask.vala"
	path = _tmp4_;
#line 322 "Utility/AsyncTask.vala"
	_tmp5_ = path;
#line 322 "Utility/AsyncTask.vala"
	if (tee_jee_file_system_file_exists (_tmp5_)) {
#line 1564 "AsyncTask.c"
		gchar* txt = NULL;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		const gchar* _tmp8_;
#line 323 "Utility/AsyncTask.vala"
		_tmp6_ = path;
#line 323 "Utility/AsyncTask.vala"
		_tmp7_ = tee_jee_file_system_file_read (_tmp6_);
#line 323 "Utility/AsyncTask.vala"
		txt = _tmp7_;
#line 324 "Utility/AsyncTask.vala"
		_tmp8_ = txt;
#line 324 "Utility/AsyncTask.vala"
		self->exit_code = atoi (_tmp8_);
#line 322 "Utility/AsyncTask.vala"
		_g_free0 (txt);
#line 1581 "AsyncTask.c"
	}
#line 326 "Utility/AsyncTask.vala"
	_tmp9_ = g_strdup_printf ("exit_code: %d", self->exit_code);
#line 326 "Utility/AsyncTask.vala"
	_tmp10_ = _tmp9_;
#line 326 "Utility/AsyncTask.vala"
	tee_jee_logging_log_debug (_tmp10_);
#line 326 "Utility/AsyncTask.vala"
	_g_free0 (_tmp10_);
#line 327 "Utility/AsyncTask.vala"
	result = self->exit_code;
#line 327 "Utility/AsyncTask.vala"
	_g_free0 (path);
#line 327 "Utility/AsyncTask.vala"
	return result;
#line 1597 "AsyncTask.c"
}

gboolean
async_task_is_running (AsyncTask* self)
{
	AppStatus _tmp0_;
	gboolean result = FALSE;
#line 330 "Utility/AsyncTask.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 331 "Utility/AsyncTask.vala"
	_tmp0_ = self->status;
#line 331 "Utility/AsyncTask.vala"
	result = _tmp0_ == APP_STATUS_RUNNING;
#line 331 "Utility/AsyncTask.vala"
	return result;
#line 1613 "AsyncTask.c"
}

void
async_task_pause (AsyncTask* self)
{
	GPid sub_child_pid = 0;
	gint _tmp0_ = 0;
	gint* _tmp1_;
#line 336 "Utility/AsyncTask.vala"
	g_return_if_fail (self != NULL);
#line 338 "Utility/AsyncTask.vala"
	_tmp1_ = tee_jee_process_helper_get_process_children (self->child_pid, &_tmp0_);
#line 1626 "AsyncTask.c"
	{
		gint* pid_collection = NULL;
		gint pid_collection_length1 = 0;
		gint _pid_collection_size_ = 0;
		gint pid_it = 0;
#line 338 "Utility/AsyncTask.vala"
		pid_collection = _tmp1_;
#line 338 "Utility/AsyncTask.vala"
		pid_collection_length1 = _tmp0_;
#line 338 "Utility/AsyncTask.vala"
		for (pid_it = 0; pid_it < pid_collection_length1; pid_it = pid_it + 1) {
#line 1638 "AsyncTask.c"
			glong pid = 0L;
#line 338 "Utility/AsyncTask.vala"
			pid = (glong) pid_collection[pid_it];
#line 1642 "AsyncTask.c"
			{
#line 339 "Utility/AsyncTask.vala"
				sub_child_pid = (GPid) pid;
#line 340 "Utility/AsyncTask.vala"
				tee_jee_process_helper_process_pause (sub_child_pid);
#line 1648 "AsyncTask.c"
			}
		}
#line 338 "Utility/AsyncTask.vala"
		pid_collection = (g_free (pid_collection), NULL);
#line 1653 "AsyncTask.c"
	}
#line 343 "Utility/AsyncTask.vala"
	self->status = APP_STATUS_PAUSED;
#line 1657 "AsyncTask.c"
}

void
async_task_resume (AsyncTask* self)
{
	GPid sub_child_pid = 0;
	gint _tmp0_ = 0;
	gint* _tmp1_;
#line 346 "Utility/AsyncTask.vala"
	g_return_if_fail (self != NULL);
#line 348 "Utility/AsyncTask.vala"
	_tmp1_ = tee_jee_process_helper_get_process_children (self->child_pid, &_tmp0_);
#line 1670 "AsyncTask.c"
	{
		gint* pid_collection = NULL;
		gint pid_collection_length1 = 0;
		gint _pid_collection_size_ = 0;
		gint pid_it = 0;
#line 348 "Utility/AsyncTask.vala"
		pid_collection = _tmp1_;
#line 348 "Utility/AsyncTask.vala"
		pid_collection_length1 = _tmp0_;
#line 348 "Utility/AsyncTask.vala"
		for (pid_it = 0; pid_it < pid_collection_length1; pid_it = pid_it + 1) {
#line 1682 "AsyncTask.c"
			glong pid = 0L;
#line 348 "Utility/AsyncTask.vala"
			pid = (glong) pid_collection[pid_it];
#line 1686 "AsyncTask.c"
			{
#line 349 "Utility/AsyncTask.vala"
				sub_child_pid = (GPid) pid;
#line 350 "Utility/AsyncTask.vala"
				tee_jee_process_helper_process_resume (sub_child_pid);
#line 1692 "AsyncTask.c"
			}
		}
#line 348 "Utility/AsyncTask.vala"
		pid_collection = (g_free (pid_collection), NULL);
#line 1697 "AsyncTask.c"
	}
#line 353 "Utility/AsyncTask.vala"
	self->status = APP_STATUS_RUNNING;
#line 1701 "AsyncTask.c"
}

void
async_task_stop (AsyncTask* self,
                 AppStatus status_to_update)
{
	AppStatus _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 356 "Utility/AsyncTask.vala"
	g_return_if_fail (self != NULL);
#line 358 "Utility/AsyncTask.vala"
	_tmp0_ = self->status;
#line 358 "Utility/AsyncTask.vala"
	if (_tmp0_ == APP_STATUS_PAUSED) {
#line 359 "Utility/AsyncTask.vala"
		async_task_resume (self);
#line 1719 "AsyncTask.c"
	}
#line 362 "Utility/AsyncTask.vala"
	self->status = status_to_update;
#line 364 "Utility/AsyncTask.vala"
	tee_jee_process_helper_process_quit (self->child_pid, TRUE);
#line 366 "Utility/AsyncTask.vala"
	_tmp1_ = g_strdup_printf ("process_quit: %d", (gint) self->child_pid);
#line 366 "Utility/AsyncTask.vala"
	_tmp2_ = _tmp1_;
#line 366 "Utility/AsyncTask.vala"
	tee_jee_logging_log_debug (_tmp2_);
#line 366 "Utility/AsyncTask.vala"
	_g_free0 (_tmp2_);
#line 1733 "AsyncTask.c"
}

void
async_task_set_priority (AsyncTask* self)
{
#line 369 "Utility/AsyncTask.vala"
	g_return_if_fail (self != NULL);
#line 370 "Utility/AsyncTask.vala"
	if (self->background_mode) {
#line 371 "Utility/AsyncTask.vala"
		async_task_set_priority_value (self, 5);
#line 1745 "AsyncTask.c"
	} else {
#line 374 "Utility/AsyncTask.vala"
		async_task_set_priority_value (self, 0);
#line 1749 "AsyncTask.c"
	}
}

void
async_task_set_priority_value (AsyncTask* self,
                               gint prio)
{
	GPid app_pid = 0;
	AppStatus _tmp0_;
#line 378 "Utility/AsyncTask.vala"
	g_return_if_fail (self != NULL);
#line 379 "Utility/AsyncTask.vala"
	app_pid = (GPid) getpid ();
#line 380 "Utility/AsyncTask.vala"
	tee_jee_process_helper_process_set_priority (app_pid, prio);
#line 382 "Utility/AsyncTask.vala"
	_tmp0_ = self->status;
#line 382 "Utility/AsyncTask.vala"
	if (_tmp0_ == APP_STATUS_RUNNING) {
#line 1769 "AsyncTask.c"
		GPid sub_child_pid = 0;
		gint _tmp1_ = 0;
		gint* _tmp2_;
#line 383 "Utility/AsyncTask.vala"
		tee_jee_process_helper_process_set_priority (self->child_pid, prio);
#line 386 "Utility/AsyncTask.vala"
		_tmp2_ = tee_jee_process_helper_get_process_children (self->child_pid, &_tmp1_);
#line 1777 "AsyncTask.c"
		{
			gint* pid_collection = NULL;
			gint pid_collection_length1 = 0;
			gint _pid_collection_size_ = 0;
			gint pid_it = 0;
#line 386 "Utility/AsyncTask.vala"
			pid_collection = _tmp2_;
#line 386 "Utility/AsyncTask.vala"
			pid_collection_length1 = _tmp1_;
#line 386 "Utility/AsyncTask.vala"
			for (pid_it = 0; pid_it < pid_collection_length1; pid_it = pid_it + 1) {
#line 1789 "AsyncTask.c"
				glong pid = 0L;
#line 386 "Utility/AsyncTask.vala"
				pid = (glong) pid_collection[pid_it];
#line 1793 "AsyncTask.c"
				{
#line 387 "Utility/AsyncTask.vala"
					sub_child_pid = (GPid) pid;
#line 388 "Utility/AsyncTask.vala"
					tee_jee_process_helper_process_set_priority (sub_child_pid, prio);
#line 1799 "AsyncTask.c"
				}
			}
#line 386 "Utility/AsyncTask.vala"
			pid_collection = (g_free (pid_collection), NULL);
#line 1804 "AsyncTask.c"
		}
	}
}

void
async_task_print_app_status (AsyncTask* self)
{
	AppStatus _tmp0_;
#line 416 "Utility/AsyncTask.vala"
	g_return_if_fail (self != NULL);
#line 417 "Utility/AsyncTask.vala"
	_tmp0_ = self->status;
#line 417 "Utility/AsyncTask.vala"
	switch (_tmp0_) {
#line 417 "Utility/AsyncTask.vala"
		case APP_STATUS_NOT_STARTED:
#line 1821 "AsyncTask.c"
		{
			gchar* _tmp1_;
			gchar* _tmp2_;
#line 419 "Utility/AsyncTask.vala"
			_tmp1_ = g_strdup_printf ("status=%s", "NOT_STARTED");
#line 419 "Utility/AsyncTask.vala"
			_tmp2_ = _tmp1_;
#line 419 "Utility/AsyncTask.vala"
			tee_jee_logging_log_debug (_tmp2_);
#line 419 "Utility/AsyncTask.vala"
			_g_free0 (_tmp2_);
#line 420 "Utility/AsyncTask.vala"
			break;
#line 1835 "AsyncTask.c"
		}
#line 417 "Utility/AsyncTask.vala"
		case APP_STATUS_RUNNING:
#line 1839 "AsyncTask.c"
		{
			gchar* _tmp3_;
			gchar* _tmp4_;
#line 422 "Utility/AsyncTask.vala"
			_tmp3_ = g_strdup_printf ("status=%s", "RUNNING");
#line 422 "Utility/AsyncTask.vala"
			_tmp4_ = _tmp3_;
#line 422 "Utility/AsyncTask.vala"
			tee_jee_logging_log_debug (_tmp4_);
#line 422 "Utility/AsyncTask.vala"
			_g_free0 (_tmp4_);
#line 423 "Utility/AsyncTask.vala"
			break;
#line 1853 "AsyncTask.c"
		}
#line 417 "Utility/AsyncTask.vala"
		case APP_STATUS_PAUSED:
#line 1857 "AsyncTask.c"
		{
			gchar* _tmp5_;
			gchar* _tmp6_;
#line 425 "Utility/AsyncTask.vala"
			_tmp5_ = g_strdup_printf ("status=%s", "PAUSED");
#line 425 "Utility/AsyncTask.vala"
			_tmp6_ = _tmp5_;
#line 425 "Utility/AsyncTask.vala"
			tee_jee_logging_log_debug (_tmp6_);
#line 425 "Utility/AsyncTask.vala"
			_g_free0 (_tmp6_);
#line 426 "Utility/AsyncTask.vala"
			break;
#line 1871 "AsyncTask.c"
		}
#line 417 "Utility/AsyncTask.vala"
		case APP_STATUS_FINISHED:
#line 1875 "AsyncTask.c"
		{
			gchar* _tmp7_;
			gchar* _tmp8_;
#line 428 "Utility/AsyncTask.vala"
			_tmp7_ = g_strdup_printf ("status=%s", "FINISHED");
#line 428 "Utility/AsyncTask.vala"
			_tmp8_ = _tmp7_;
#line 428 "Utility/AsyncTask.vala"
			tee_jee_logging_log_debug (_tmp8_);
#line 428 "Utility/AsyncTask.vala"
			_g_free0 (_tmp8_);
#line 429 "Utility/AsyncTask.vala"
			break;
#line 1889 "AsyncTask.c"
		}
#line 417 "Utility/AsyncTask.vala"
		case APP_STATUS_CANCELLED:
#line 1893 "AsyncTask.c"
		{
			gchar* _tmp9_;
			gchar* _tmp10_;
#line 431 "Utility/AsyncTask.vala"
			_tmp9_ = g_strdup_printf ("status=%s", "CANCELLED");
#line 431 "Utility/AsyncTask.vala"
			_tmp10_ = _tmp9_;
#line 431 "Utility/AsyncTask.vala"
			tee_jee_logging_log_debug (_tmp10_);
#line 431 "Utility/AsyncTask.vala"
			_g_free0 (_tmp10_);
#line 432 "Utility/AsyncTask.vala"
			break;
#line 1907 "AsyncTask.c"
		}
#line 417 "Utility/AsyncTask.vala"
		case APP_STATUS_PASSWORD_REQUIRED:
#line 1911 "AsyncTask.c"
		{
			gchar* _tmp11_;
			gchar* _tmp12_;
#line 434 "Utility/AsyncTask.vala"
			_tmp11_ = g_strdup_printf ("status=%s", "PASSWORD_REQUIRED");
#line 434 "Utility/AsyncTask.vala"
			_tmp12_ = _tmp11_;
#line 434 "Utility/AsyncTask.vala"
			tee_jee_logging_log_debug (_tmp12_);
#line 434 "Utility/AsyncTask.vala"
			_g_free0 (_tmp12_);
#line 435 "Utility/AsyncTask.vala"
			break;
#line 1925 "AsyncTask.c"
		}
		default:
#line 417 "Utility/AsyncTask.vala"
		break;
#line 1930 "AsyncTask.c"
	}
}

gchar*
async_task_get_stat_time_elapsed (AsyncTask* self)
{
	gchar* result;
	glong elapsed = 0L;
	GTimer* _tmp0_;
	gchar* _tmp1_;
#line 394 "Utility/AsyncTask.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 395 "Utility/AsyncTask.vala"
	_tmp0_ = self->timer;
#line 395 "Utility/AsyncTask.vala"
	elapsed = (glong) tee_jee_system_timer_elapsed (_tmp0_, TRUE);
#line 396 "Utility/AsyncTask.vala"
	_tmp1_ = tee_jee_misc_format_duration (elapsed);
#line 396 "Utility/AsyncTask.vala"
	result = _tmp1_;
#line 396 "Utility/AsyncTask.vala"
	return result;
#line 1953 "AsyncTask.c"
}

gchar*
async_task_get_stat_time_remaining (AsyncTask* self)
{
	gchar* result;
#line 401 "Utility/AsyncTask.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 402 "Utility/AsyncTask.vala"
	if (self->progress > ((gdouble) 0)) {
#line 1964 "AsyncTask.c"
		glong elapsed = 0L;
		GTimer* _tmp0_;
		glong remaining = 0L;
		gchar* _tmp1_;
#line 403 "Utility/AsyncTask.vala"
		_tmp0_ = self->timer;
#line 403 "Utility/AsyncTask.vala"
		elapsed = (glong) tee_jee_system_timer_elapsed (_tmp0_, TRUE);
#line 404 "Utility/AsyncTask.vala"
		remaining = (glong) ((elapsed / self->progress) * (1.0 - self->progress));
#line 405 "Utility/AsyncTask.vala"
		if (remaining < ((glong) 0)) {
#line 406 "Utility/AsyncTask.vala"
			remaining = (glong) 0;
#line 1979 "AsyncTask.c"
		}
#line 408 "Utility/AsyncTask.vala"
		_tmp1_ = tee_jee_misc_format_duration (remaining);
#line 408 "Utility/AsyncTask.vala"
		result = _tmp1_;
#line 408 "Utility/AsyncTask.vala"
		return result;
#line 1987 "AsyncTask.c"
	} else {
		gchar* _tmp2_;
#line 411 "Utility/AsyncTask.vala"
		_tmp2_ = g_strdup ("???");
#line 411 "Utility/AsyncTask.vala"
		result = _tmp2_;
#line 411 "Utility/AsyncTask.vala"
		return result;
#line 1996 "AsyncTask.c"
	}
}

static void
async_task_class_init (AsyncTaskClass * klass,
                       gpointer klass_data)
{
#line 31 "Utility/AsyncTask.vala"
	async_task_parent_class = g_type_class_peek_parent (klass);
#line 31 "Utility/AsyncTask.vala"
	g_type_class_adjust_private_offset (klass, &AsyncTask_private_offset);
#line 31 "Utility/AsyncTask.vala"
	((AsyncTaskClass *) klass)->parse_stdout_line = (void (*) (AsyncTask*, const gchar*)) async_task_real_parse_stdout_line;
#line 31 "Utility/AsyncTask.vala"
	((AsyncTaskClass *) klass)->parse_stderr_line = (void (*) (AsyncTask*, const gchar*)) async_task_real_parse_stderr_line;
#line 31 "Utility/AsyncTask.vala"
	((AsyncTaskClass *) klass)->finish_task = (void (*) (AsyncTask*)) async_task_real_finish_task;
#line 31 "Utility/AsyncTask.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_async_task_get_property;
#line 31 "Utility/AsyncTask.vala"
	G_OBJECT_CLASS (klass)->finalize = async_task_finalize;
#line 31 "Utility/AsyncTask.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ASYNC_TASK_STAT_TIME_ELAPSED_PROPERTY, async_task_properties[ASYNC_TASK_STAT_TIME_ELAPSED_PROPERTY] = g_param_spec_string ("stat-time-elapsed", "stat-time-elapsed", "stat-time-elapsed", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 31 "Utility/AsyncTask.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ASYNC_TASK_STAT_TIME_REMAINING_PROPERTY, async_task_properties[ASYNC_TASK_STAT_TIME_REMAINING_PROPERTY] = g_param_spec_string ("stat-time-remaining", "stat-time-remaining", "stat-time-remaining", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 31 "Utility/AsyncTask.vala"
	async_task_signals[ASYNC_TASK_STDOUT_LINE_READ_SIGNAL] = g_signal_new ("stdout-line-read", TYPE_ASYNC_TASK, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 31 "Utility/AsyncTask.vala"
	async_task_signals[ASYNC_TASK_STDERR_LINE_READ_SIGNAL] = g_signal_new ("stderr-line-read", TYPE_ASYNC_TASK, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 31 "Utility/AsyncTask.vala"
	async_task_signals[ASYNC_TASK_TASK_COMPLETE_SIGNAL] = g_signal_new ("task-complete", TYPE_ASYNC_TASK, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 2028 "AsyncTask.c"
}

static void
async_task_instance_init (AsyncTask * self,
                          gpointer klass)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
#line 31 "Utility/AsyncTask.vala"
	self->priv = async_task_get_instance_private (self);
#line 33 "Utility/AsyncTask.vala"
	_tmp0_ = g_strdup ("");
#line 33 "Utility/AsyncTask.vala"
	self->priv->err_line = _tmp0_;
#line 34 "Utility/AsyncTask.vala"
	_tmp1_ = g_strdup ("");
#line 34 "Utility/AsyncTask.vala"
	self->priv->out_line = _tmp1_;
#line 39 "Utility/AsyncTask.vala"
	self->is_terminated = FALSE;
#line 41 "Utility/AsyncTask.vala"
	self->priv->stdout_is_open = FALSE;
#line 42 "Utility/AsyncTask.vala"
	self->priv->stderr_is_open = FALSE;
#line 48 "Utility/AsyncTask.vala"
	self->priv->finish_called = FALSE;
#line 50 "Utility/AsyncTask.vala"
	_tmp2_ = g_strdup ("");
#line 50 "Utility/AsyncTask.vala"
	self->script_file = _tmp2_;
#line 51 "Utility/AsyncTask.vala"
	_tmp3_ = g_strdup ("");
#line 51 "Utility/AsyncTask.vala"
	self->working_dir = _tmp3_;
#line 52 "Utility/AsyncTask.vala"
	_tmp4_ = g_strdup ("");
#line 52 "Utility/AsyncTask.vala"
	self->log_file = _tmp4_;
#line 54 "Utility/AsyncTask.vala"
	self->background_mode = FALSE;
#line 58 "Utility/AsyncTask.vala"
	_tmp5_ = g_strdup ("");
#line 58 "Utility/AsyncTask.vala"
	self->status_line = _tmp5_;
#line 59 "Utility/AsyncTask.vala"
	self->exit_code = 0;
#line 60 "Utility/AsyncTask.vala"
	_tmp6_ = g_strdup ("");
#line 60 "Utility/AsyncTask.vala"
	self->error_msg = _tmp6_;
#line 62 "Utility/AsyncTask.vala"
	self->progress = 0.0;
#line 63 "Utility/AsyncTask.vala"
	self->percent = 0.0;
#line 64 "Utility/AsyncTask.vala"
	self->prg_count = (gint64) 0;
#line 65 "Utility/AsyncTask.vala"
	self->prg_count_total = (gint64) 0;
#line 66 "Utility/AsyncTask.vala"
	self->prg_bytes = (gint64) 0;
#line 67 "Utility/AsyncTask.vala"
	self->prg_bytes_total = (gint64) 0;
#line 68 "Utility/AsyncTask.vala"
	_tmp7_ = g_strdup ("");
#line 68 "Utility/AsyncTask.vala"
	self->eta = _tmp7_;
#line 2101 "AsyncTask.c"
}

static void
async_task_finalize (GObject * obj)
{
	AsyncTask * self;
#line 31 "Utility/AsyncTask.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ASYNC_TASK, AsyncTask);
#line 33 "Utility/AsyncTask.vala"
	_g_free0 (self->priv->err_line);
#line 34 "Utility/AsyncTask.vala"
	_g_free0 (self->priv->out_line);
#line 35 "Utility/AsyncTask.vala"
	_g_object_unref0 (self->priv->dos_in);
#line 36 "Utility/AsyncTask.vala"
	_g_object_unref0 (self->priv->dis_out);
#line 37 "Utility/AsyncTask.vala"
	_g_object_unref0 (self->priv->dis_err);
#line 38 "Utility/AsyncTask.vala"
	_g_object_unref0 (self->dos_log);
#line 50 "Utility/AsyncTask.vala"
	_g_free0 (self->script_file);
#line 51 "Utility/AsyncTask.vala"
	_g_free0 (self->working_dir);
#line 52 "Utility/AsyncTask.vala"
	_g_free0 (self->log_file);
#line 58 "Utility/AsyncTask.vala"
	_g_free0 (self->status_line);
#line 60 "Utility/AsyncTask.vala"
	_g_free0 (self->error_msg);
#line 61 "Utility/AsyncTask.vala"
	_g_timer_destroy0 (self->timer);
#line 68 "Utility/AsyncTask.vala"
	_g_free0 (self->eta);
#line 31 "Utility/AsyncTask.vala"
	G_OBJECT_CLASS (async_task_parent_class)->finalize (obj);
#line 2138 "AsyncTask.c"
}

GType
async_task_get_type (void)
{
	static volatile gsize async_task_type_id__volatile = 0;
	if (g_once_init_enter (&async_task_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (AsyncTaskClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) async_task_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AsyncTask), 0, (GInstanceInitFunc) async_task_instance_init, NULL };
		GType async_task_type_id;
		async_task_type_id = g_type_register_static (G_TYPE_OBJECT, "AsyncTask", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		AsyncTask_private_offset = g_type_add_instance_private (async_task_type_id, sizeof (AsyncTaskPrivate));
		g_once_init_leave (&async_task_type_id__volatile, async_task_type_id);
	}
	return async_task_type_id__volatile;
}

static void
_vala_async_task_get_property (GObject * object,
                               guint property_id,
                               GValue * value,
                               GParamSpec * pspec)
{
	AsyncTask * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_ASYNC_TASK, AsyncTask);
#line 31 "Utility/AsyncTask.vala"
	switch (property_id) {
#line 31 "Utility/AsyncTask.vala"
		case ASYNC_TASK_STAT_TIME_ELAPSED_PROPERTY:
#line 31 "Utility/AsyncTask.vala"
		g_value_take_string (value, async_task_get_stat_time_elapsed (self));
#line 31 "Utility/AsyncTask.vala"
		break;
#line 31 "Utility/AsyncTask.vala"
		case ASYNC_TASK_STAT_TIME_REMAINING_PROPERTY:
#line 31 "Utility/AsyncTask.vala"
		g_value_take_string (value, async_task_get_stat_time_remaining (self));
#line 31 "Utility/AsyncTask.vala"
		break;
#line 2177 "AsyncTask.c"
		default:
#line 31 "Utility/AsyncTask.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 31 "Utility/AsyncTask.vala"
		break;
#line 2183 "AsyncTask.c"
	}
}

GType
app_status_get_type (void)
{
	static volatile gsize app_status_type_id__volatile = 0;
	if (g_once_init_enter (&app_status_type_id__volatile)) {
		static const GEnumValue values[] = {{APP_STATUS_NOT_STARTED, "APP_STATUS_NOT_STARTED", "not-started"}, {APP_STATUS_RUNNING, "APP_STATUS_RUNNING", "running"}, {APP_STATUS_PAUSED, "APP_STATUS_PAUSED", "paused"}, {APP_STATUS_FINISHED, "APP_STATUS_FINISHED", "finished"}, {APP_STATUS_CANCELLED, "APP_STATUS_CANCELLED", "cancelled"}, {APP_STATUS_PASSWORD_REQUIRED, "APP_STATUS_PASSWORD_REQUIRED", "password-required"}, {0, NULL, NULL}};
		GType app_status_type_id;
		app_status_type_id = g_enum_register_static ("AppStatus", values);
		g_once_init_leave (&app_status_type_id__volatile, app_status_type_id);
	}
	return app_status_type_id__volatile;
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

