/* FsTabEntry.c generated by valac 0.44.11, the Vala compiler
 * generated from FsTabEntry.vala, do not modify */

/*
 * FsTabEntry.vala
 *
 * Copyright 2012-2018 Tony George <teejeetech@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 *
 *
 */

#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <gtk/gtk.h>

#define TYPE_FS_TAB_ENTRY (fs_tab_entry_get_type ())
#define FS_TAB_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FS_TAB_ENTRY, FsTabEntry))
#define FS_TAB_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_FS_TAB_ENTRY, FsTabEntryClass))
#define IS_FS_TAB_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FS_TAB_ENTRY))
#define IS_FS_TAB_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_FS_TAB_ENTRY))
#define FS_TAB_ENTRY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_FS_TAB_ENTRY, FsTabEntryClass))

typedef struct _FsTabEntry FsTabEntry;
typedef struct _FsTabEntryClass FsTabEntryClass;
typedef struct _FsTabEntryPrivate FsTabEntryPrivate;
enum  {
	FS_TAB_ENTRY_0_PROPERTY,
	FS_TAB_ENTRY_DEVICE_UUID_PROPERTY,
	FS_TAB_ENTRY_NUM_PROPERTIES
};
static GParamSpec* fs_tab_entry_properties[FS_TAB_ENTRY_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_CRYPT_TAB_ENTRY (crypt_tab_entry_get_type ())
#define CRYPT_TAB_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CRYPT_TAB_ENTRY, CryptTabEntry))
#define CRYPT_TAB_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CRYPT_TAB_ENTRY, CryptTabEntryClass))
#define IS_CRYPT_TAB_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CRYPT_TAB_ENTRY))
#define IS_CRYPT_TAB_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CRYPT_TAB_ENTRY))
#define CRYPT_TAB_ENTRY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CRYPT_TAB_ENTRY, CryptTabEntryClass))

typedef struct _CryptTabEntry CryptTabEntry;
typedef struct _CryptTabEntryClass CryptTabEntryClass;

#define TYPE_DEVICE (device_get_type ())
#define DEVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DEVICE, Device))
#define DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DEVICE, DeviceClass))
#define IS_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DEVICE))
#define IS_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DEVICE))
#define DEVICE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DEVICE, DeviceClass))

typedef struct _Device Device;
typedef struct _DeviceClass DeviceClass;
typedef struct _CryptTabEntryPrivate CryptTabEntryPrivate;

struct _FsTabEntry {
	GObject parent_instance;
	FsTabEntryPrivate * priv;
	gboolean is_comment;
	gboolean is_empty_line;
	gchar* device_string;
	gchar* mount_point;
	gchar* type;
	gchar* options;
	gchar* dump;
	gchar* pass;
	gchar* line;
};

struct _FsTabEntryClass {
	GObjectClass parent_class;
};

struct _CryptTabEntry {
	GObject parent_instance;
	CryptTabEntryPrivate * priv;
	gboolean is_comment;
	gboolean is_empty_line;
	gchar* mapped_name;
	gchar* device_string;
	gchar* keyfile;
	gchar* options;
	gchar* line;
};

struct _CryptTabEntryClass {
	GObjectClass parent_class;
};

static gpointer fs_tab_entry_parent_class = NULL;

GType fs_tab_entry_get_type (void) G_GNUC_CONST;
GeeArrayList* fs_tab_entry_read_file (const gchar* file_path);
gboolean tee_jee_file_system_file_exists (const gchar* file_path);
gchar* tee_jee_file_system_file_read (const gchar* file_path);
FsTabEntry* fs_tab_entry_new (void);
FsTabEntry* fs_tab_entry_construct (GType object_type);
gchar* fs_tab_entry_write_file (GeeArrayList* entries,
                                const gchar* file_path,
                                gboolean keep_comments_and_empty_lines);
static gint __lambda6_ (FsTabEntry* a,
                 FsTabEntry* b);
static gint ___lambda6__gcompare_data_func (gconstpointer a,
                                     gconstpointer b,
                                     gpointer self);
gboolean tee_jee_file_system_file_delete (const gchar* file_path);
gboolean tee_jee_file_system_file_write (const gchar* file_path,
                                         const gchar* contents);
gchar* fs_tab_entry_subvolume_name (FsTabEntry* self);
gboolean fs_tab_entry_is_for_system_directory (FsTabEntry* self);
FsTabEntry* fs_tab_entry_find_entry_by_mount_point (GeeArrayList* entries,
                                                    const gchar* mount_path);
GType crypt_tab_entry_get_type (void) G_GNUC_CONST;
GType device_get_type (void) G_GNUC_CONST;
Device* fs_tab_entry_resolve_device (FsTabEntry* self,
                                     GeeArrayList* crypttab,
                                     GtkWindow* parent_window);
gchar* fs_tab_entry_get_device_uuid (FsTabEntry* self);
Device* device_get_device_by_uuid (const gchar* uuid);
Device* device_get_device_by_name (const gchar* file_name);
Device* device_luks_unlock (Device* luks_device,
                            const gchar* mapped_name,
                            const gchar* passphrase,
                            GtkWindow* parent_window,
                            gchar* * message,
                            gchar* * details);
void fs_tab_entry_append_option (FsTabEntry* self,
                                 const gchar* option);
void fs_tab_entry_remove_option (FsTabEntry* self,
                                 const gchar* option);
void fs_tab_entry_set_device_uuid (FsTabEntry* self,
                                   const gchar* value);
static void fs_tab_entry_finalize (GObject * obj);
static void _vala_fs_tab_entry_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec);
static void _vala_fs_tab_entry_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result = NULL;
#line 1307 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1308 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1308 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1309 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1310 "glib-2.0.vapi"
	result = _result_;
#line 1310 "glib-2.0.vapi"
	return result;
#line 189 "FsTabEntry.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
#line 1482 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1482 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1482 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1483 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1483 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 211 "FsTabEntry.c"
	} else {
#line 1483 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 215 "FsTabEntry.c"
	}
#line 1483 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1483 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 221 "FsTabEntry.c"
	} else {
#line 1483 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 225 "FsTabEntry.c"
	}
#line 1483 "glib-2.0.vapi"
	if (_tmp0_) {
#line 229 "FsTabEntry.c"
		gchar* _tmp2_;
#line 1484 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1484 "glib-2.0.vapi"
		result = _tmp2_;
#line 1484 "glib-2.0.vapi"
		return result;
#line 237 "FsTabEntry.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1487 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1487 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1487 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1487 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1487 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1487 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1487 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1487 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 265 "FsTabEntry.c"
				goto __catch53_g_regex_error;
			}
#line 1487 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1487 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1487 "glib-2.0.vapi"
			return NULL;
#line 274 "FsTabEntry.c"
		}
#line 1488 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1488 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1488 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1488 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1488 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1488 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 288 "FsTabEntry.c"
				goto __catch53_g_regex_error;
			}
#line 1488 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1488 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1488 "glib-2.0.vapi"
			return NULL;
#line 297 "FsTabEntry.c"
		}
#line 1488 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1488 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1488 "glib-2.0.vapi"
		result = _tmp10_;
#line 1488 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1488 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1488 "glib-2.0.vapi"
		return result;
#line 311 "FsTabEntry.c"
	}
	goto __finally53;
	__catch53_g_regex_error:
	{
		GError* e = NULL;
#line 1486 "glib-2.0.vapi"
		e = _inner_error0_;
#line 1486 "glib-2.0.vapi"
		_inner_error0_ = NULL;
#line 1490 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 1486 "glib-2.0.vapi"
		_g_error_free0 (e);
#line 325 "FsTabEntry.c"
	}
	__finally53:
#line 1486 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1486 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1486 "glib-2.0.vapi"
	return NULL;
#line 334 "FsTabEntry.c"
}

GeeArrayList*
fs_tab_entry_read_file (const gchar* file_path)
{
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp0_;
	gchar* text = NULL;
	gchar* _tmp1_;
	gchar** lines = NULL;
	const gchar* _tmp2_;
	gchar** _tmp3_;
	gchar** _tmp4_;
	gint lines_length1;
	gint _lines_size_;
	gchar** _tmp5_;
	gint _tmp5__length1;
	GeeArrayList* result = NULL;
#line 59 "Utility/FsTabEntry.vala"
	g_return_val_if_fail (file_path != NULL, NULL);
#line 61 "Utility/FsTabEntry.vala"
	_tmp0_ = gee_array_list_new (TYPE_FS_TAB_ENTRY, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 61 "Utility/FsTabEntry.vala"
	list = _tmp0_;
#line 63 "Utility/FsTabEntry.vala"
	if (!tee_jee_file_system_file_exists (file_path)) {
#line 63 "Utility/FsTabEntry.vala"
		result = list;
#line 63 "Utility/FsTabEntry.vala"
		return result;
#line 365 "FsTabEntry.c"
	}
#line 65 "Utility/FsTabEntry.vala"
	_tmp1_ = tee_jee_file_system_file_read (file_path);
#line 65 "Utility/FsTabEntry.vala"
	text = _tmp1_;
#line 67 "Utility/FsTabEntry.vala"
	_tmp2_ = text;
#line 67 "Utility/FsTabEntry.vala"
	_tmp4_ = _tmp3_ = g_strsplit (_tmp2_, "\n", 0);
#line 67 "Utility/FsTabEntry.vala"
	lines = _tmp4_;
#line 67 "Utility/FsTabEntry.vala"
	lines_length1 = _vala_array_length (_tmp3_);
#line 67 "Utility/FsTabEntry.vala"
	_lines_size_ = lines_length1;
#line 69 "Utility/FsTabEntry.vala"
	_tmp5_ = lines;
#line 69 "Utility/FsTabEntry.vala"
	_tmp5__length1 = lines_length1;
#line 385 "FsTabEntry.c"
	{
		gchar** line_collection = NULL;
		gint line_collection_length1 = 0;
		gint _line_collection_size_ = 0;
		gint line_it = 0;
#line 69 "Utility/FsTabEntry.vala"
		line_collection = _tmp5_;
#line 69 "Utility/FsTabEntry.vala"
		line_collection_length1 = _tmp5__length1;
#line 69 "Utility/FsTabEntry.vala"
		for (line_it = 0; line_it < line_collection_length1; line_it = line_it + 1) {
#line 397 "FsTabEntry.c"
			gchar* _tmp6_;
			gchar* line = NULL;
#line 69 "Utility/FsTabEntry.vala"
			_tmp6_ = g_strdup (line_collection[line_it]);
#line 69 "Utility/FsTabEntry.vala"
			line = _tmp6_;
#line 404 "FsTabEntry.c"
			{
				FsTabEntry* entry = NULL;
				FsTabEntry* _tmp7_;
				GeeArrayList* _tmp8_;
				FsTabEntry* _tmp9_;
				FsTabEntry* _tmp10_;
				const gchar* _tmp11_;
				gchar* _tmp12_;
				gchar* _tmp13_;
				FsTabEntry* _tmp14_;
				const gchar* _tmp15_;
				gchar* _tmp16_;
				gchar* _tmp17_;
				gint _tmp18_;
				gint _tmp19_;
				FsTabEntry* _tmp20_;
#line 71 "Utility/FsTabEntry.vala"
				_tmp7_ = fs_tab_entry_new ();
#line 71 "Utility/FsTabEntry.vala"
				entry = _tmp7_;
#line 72 "Utility/FsTabEntry.vala"
				_tmp8_ = list;
#line 72 "Utility/FsTabEntry.vala"
				_tmp9_ = entry;
#line 72 "Utility/FsTabEntry.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp8_, _tmp9_);
#line 74 "Utility/FsTabEntry.vala"
				_tmp10_ = entry;
#line 74 "Utility/FsTabEntry.vala"
				_tmp11_ = line;
#line 74 "Utility/FsTabEntry.vala"
				_tmp12_ = string_strip (_tmp11_);
#line 74 "Utility/FsTabEntry.vala"
				_tmp13_ = _tmp12_;
#line 74 "Utility/FsTabEntry.vala"
				_tmp10_->is_comment = g_str_has_prefix (_tmp13_, "#");
#line 74 "Utility/FsTabEntry.vala"
				_g_free0 (_tmp13_);
#line 75 "Utility/FsTabEntry.vala"
				_tmp14_ = entry;
#line 75 "Utility/FsTabEntry.vala"
				_tmp15_ = line;
#line 75 "Utility/FsTabEntry.vala"
				_tmp16_ = string_strip (_tmp15_);
#line 75 "Utility/FsTabEntry.vala"
				_tmp17_ = _tmp16_;
#line 75 "Utility/FsTabEntry.vala"
				_tmp18_ = strlen (_tmp17_);
#line 75 "Utility/FsTabEntry.vala"
				_tmp19_ = _tmp18_;
#line 75 "Utility/FsTabEntry.vala"
				_tmp14_->is_empty_line = _tmp19_ == 0;
#line 75 "Utility/FsTabEntry.vala"
				_g_free0 (_tmp17_);
#line 77 "Utility/FsTabEntry.vala"
				_tmp20_ = entry;
#line 77 "Utility/FsTabEntry.vala"
				if (_tmp20_->is_comment) {
#line 463 "FsTabEntry.c"
					FsTabEntry* _tmp21_;
					const gchar* _tmp22_;
					gchar* _tmp23_;
#line 79 "Utility/FsTabEntry.vala"
					_tmp21_ = entry;
#line 79 "Utility/FsTabEntry.vala"
					_tmp22_ = line;
#line 79 "Utility/FsTabEntry.vala"
					_tmp23_ = g_strdup (_tmp22_);
#line 79 "Utility/FsTabEntry.vala"
					_g_free0 (_tmp21_->line);
#line 79 "Utility/FsTabEntry.vala"
					_tmp21_->line = _tmp23_;
#line 477 "FsTabEntry.c"
				} else {
					FsTabEntry* _tmp24_;
#line 81 "Utility/FsTabEntry.vala"
					_tmp24_ = entry;
#line 81 "Utility/FsTabEntry.vala"
					if (_tmp24_->is_empty_line) {
#line 484 "FsTabEntry.c"
						FsTabEntry* _tmp25_;
						gchar* _tmp26_;
#line 83 "Utility/FsTabEntry.vala"
						_tmp25_ = entry;
#line 83 "Utility/FsTabEntry.vala"
						_tmp26_ = g_strdup ("");
#line 83 "Utility/FsTabEntry.vala"
						_g_free0 (_tmp25_->line);
#line 83 "Utility/FsTabEntry.vala"
						_tmp25_->line = _tmp26_;
#line 495 "FsTabEntry.c"
					} else {
						FsTabEntry* _tmp27_;
						const gchar* _tmp28_;
						gchar* _tmp29_;
						gchar** parts = NULL;
						const gchar* _tmp30_;
						gchar* _tmp31_;
						gchar* _tmp32_;
						gchar** _tmp33_;
						gchar** _tmp34_;
						gchar** _tmp35_;
						gint _tmp35__length1;
						gint parts_length1;
						gint _parts_size_;
						gint part_num = 0;
						gchar** _tmp36_;
						gint _tmp36__length1;
#line 86 "Utility/FsTabEntry.vala"
						_tmp27_ = entry;
#line 86 "Utility/FsTabEntry.vala"
						_tmp28_ = line;
#line 86 "Utility/FsTabEntry.vala"
						_tmp29_ = g_strdup (_tmp28_);
#line 86 "Utility/FsTabEntry.vala"
						_g_free0 (_tmp27_->line);
#line 86 "Utility/FsTabEntry.vala"
						_tmp27_->line = _tmp29_;
#line 88 "Utility/FsTabEntry.vala"
						_tmp30_ = line;
#line 88 "Utility/FsTabEntry.vala"
						_tmp31_ = string_replace (_tmp30_, "\t", " ");
#line 88 "Utility/FsTabEntry.vala"
						_tmp32_ = _tmp31_;
#line 88 "Utility/FsTabEntry.vala"
						_tmp34_ = _tmp33_ = g_strsplit (_tmp32_, " ", 0);
#line 88 "Utility/FsTabEntry.vala"
						_tmp35_ = _tmp34_;
#line 88 "Utility/FsTabEntry.vala"
						_tmp35__length1 = _vala_array_length (_tmp33_);
#line 88 "Utility/FsTabEntry.vala"
						_g_free0 (_tmp32_);
#line 88 "Utility/FsTabEntry.vala"
						parts = _tmp35_;
#line 88 "Utility/FsTabEntry.vala"
						parts_length1 = _tmp35__length1;
#line 88 "Utility/FsTabEntry.vala"
						_parts_size_ = parts_length1;
#line 90 "Utility/FsTabEntry.vala"
						part_num = -1;
#line 92 "Utility/FsTabEntry.vala"
						_tmp36_ = parts;
#line 92 "Utility/FsTabEntry.vala"
						_tmp36__length1 = parts_length1;
#line 549 "FsTabEntry.c"
						{
							gchar** part_collection = NULL;
							gint part_collection_length1 = 0;
							gint _part_collection_size_ = 0;
							gint part_it = 0;
#line 92 "Utility/FsTabEntry.vala"
							part_collection = _tmp36_;
#line 92 "Utility/FsTabEntry.vala"
							part_collection_length1 = _tmp36__length1;
#line 92 "Utility/FsTabEntry.vala"
							for (part_it = 0; part_it < part_collection_length1; part_it = part_it + 1) {
#line 561 "FsTabEntry.c"
								gchar* _tmp37_;
								gchar* part = NULL;
#line 92 "Utility/FsTabEntry.vala"
								_tmp37_ = g_strdup (part_collection[part_it]);
#line 92 "Utility/FsTabEntry.vala"
								part = _tmp37_;
#line 568 "FsTabEntry.c"
								{
									const gchar* _tmp38_;
									gchar* _tmp39_;
									gchar* _tmp40_;
									gint _tmp41_;
									gint _tmp42_;
									gboolean _tmp43_;
#line 94 "Utility/FsTabEntry.vala"
									_tmp38_ = part;
#line 94 "Utility/FsTabEntry.vala"
									_tmp39_ = string_strip (_tmp38_);
#line 94 "Utility/FsTabEntry.vala"
									_tmp40_ = _tmp39_;
#line 94 "Utility/FsTabEntry.vala"
									_tmp41_ = strlen (_tmp40_);
#line 94 "Utility/FsTabEntry.vala"
									_tmp42_ = _tmp41_;
#line 94 "Utility/FsTabEntry.vala"
									_tmp43_ = _tmp42_ == 0;
#line 94 "Utility/FsTabEntry.vala"
									_g_free0 (_tmp40_);
#line 94 "Utility/FsTabEntry.vala"
									if (_tmp43_) {
#line 94 "Utility/FsTabEntry.vala"
										_g_free0 (part);
#line 94 "Utility/FsTabEntry.vala"
										continue;
#line 596 "FsTabEntry.c"
									}
#line 96 "Utility/FsTabEntry.vala"
									part_num = part_num + 1;
#line 96 "Utility/FsTabEntry.vala"
									switch (part_num) {
#line 96 "Utility/FsTabEntry.vala"
										case 0:
#line 604 "FsTabEntry.c"
										{
											FsTabEntry* _tmp44_;
											const gchar* _tmp45_;
											gchar* _tmp46_;
#line 98 "Utility/FsTabEntry.vala"
											_tmp44_ = entry;
#line 98 "Utility/FsTabEntry.vala"
											_tmp45_ = part;
#line 98 "Utility/FsTabEntry.vala"
											_tmp46_ = string_strip (_tmp45_);
#line 98 "Utility/FsTabEntry.vala"
											_g_free0 (_tmp44_->device_string);
#line 98 "Utility/FsTabEntry.vala"
											_tmp44_->device_string = _tmp46_;
#line 99 "Utility/FsTabEntry.vala"
											break;
#line 621 "FsTabEntry.c"
										}
#line 96 "Utility/FsTabEntry.vala"
										case 1:
#line 625 "FsTabEntry.c"
										{
											FsTabEntry* _tmp47_;
											const gchar* _tmp48_;
											gchar* _tmp49_;
#line 101 "Utility/FsTabEntry.vala"
											_tmp47_ = entry;
#line 101 "Utility/FsTabEntry.vala"
											_tmp48_ = part;
#line 101 "Utility/FsTabEntry.vala"
											_tmp49_ = string_strip (_tmp48_);
#line 101 "Utility/FsTabEntry.vala"
											_g_free0 (_tmp47_->mount_point);
#line 101 "Utility/FsTabEntry.vala"
											_tmp47_->mount_point = _tmp49_;
#line 102 "Utility/FsTabEntry.vala"
											break;
#line 642 "FsTabEntry.c"
										}
#line 96 "Utility/FsTabEntry.vala"
										case 2:
#line 646 "FsTabEntry.c"
										{
											FsTabEntry* _tmp50_;
											const gchar* _tmp51_;
											gchar* _tmp52_;
#line 104 "Utility/FsTabEntry.vala"
											_tmp50_ = entry;
#line 104 "Utility/FsTabEntry.vala"
											_tmp51_ = part;
#line 104 "Utility/FsTabEntry.vala"
											_tmp52_ = string_strip (_tmp51_);
#line 104 "Utility/FsTabEntry.vala"
											_g_free0 (_tmp50_->type);
#line 104 "Utility/FsTabEntry.vala"
											_tmp50_->type = _tmp52_;
#line 105 "Utility/FsTabEntry.vala"
											break;
#line 663 "FsTabEntry.c"
										}
#line 96 "Utility/FsTabEntry.vala"
										case 3:
#line 667 "FsTabEntry.c"
										{
											FsTabEntry* _tmp53_;
											const gchar* _tmp54_;
											gchar* _tmp55_;
#line 107 "Utility/FsTabEntry.vala"
											_tmp53_ = entry;
#line 107 "Utility/FsTabEntry.vala"
											_tmp54_ = part;
#line 107 "Utility/FsTabEntry.vala"
											_tmp55_ = string_strip (_tmp54_);
#line 107 "Utility/FsTabEntry.vala"
											_g_free0 (_tmp53_->options);
#line 107 "Utility/FsTabEntry.vala"
											_tmp53_->options = _tmp55_;
#line 108 "Utility/FsTabEntry.vala"
											break;
#line 684 "FsTabEntry.c"
										}
#line 96 "Utility/FsTabEntry.vala"
										case 4:
#line 688 "FsTabEntry.c"
										{
											FsTabEntry* _tmp56_;
											const gchar* _tmp57_;
											gchar* _tmp58_;
#line 110 "Utility/FsTabEntry.vala"
											_tmp56_ = entry;
#line 110 "Utility/FsTabEntry.vala"
											_tmp57_ = part;
#line 110 "Utility/FsTabEntry.vala"
											_tmp58_ = string_strip (_tmp57_);
#line 110 "Utility/FsTabEntry.vala"
											_g_free0 (_tmp56_->dump);
#line 110 "Utility/FsTabEntry.vala"
											_tmp56_->dump = _tmp58_;
#line 111 "Utility/FsTabEntry.vala"
											break;
#line 705 "FsTabEntry.c"
										}
#line 96 "Utility/FsTabEntry.vala"
										case 5:
#line 709 "FsTabEntry.c"
										{
											FsTabEntry* _tmp59_;
											const gchar* _tmp60_;
											gchar* _tmp61_;
#line 113 "Utility/FsTabEntry.vala"
											_tmp59_ = entry;
#line 113 "Utility/FsTabEntry.vala"
											_tmp60_ = part;
#line 113 "Utility/FsTabEntry.vala"
											_tmp61_ = string_strip (_tmp60_);
#line 113 "Utility/FsTabEntry.vala"
											_g_free0 (_tmp59_->pass);
#line 113 "Utility/FsTabEntry.vala"
											_tmp59_->pass = _tmp61_;
#line 114 "Utility/FsTabEntry.vala"
											break;
#line 726 "FsTabEntry.c"
										}
										default:
#line 96 "Utility/FsTabEntry.vala"
										break;
#line 731 "FsTabEntry.c"
									}
#line 92 "Utility/FsTabEntry.vala"
									_g_free0 (part);
#line 735 "FsTabEntry.c"
								}
							}
						}
#line 81 "Utility/FsTabEntry.vala"
						parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 741 "FsTabEntry.c"
					}
				}
#line 69 "Utility/FsTabEntry.vala"
				_g_object_unref0 (entry);
#line 69 "Utility/FsTabEntry.vala"
				_g_free0 (line);
#line 748 "FsTabEntry.c"
			}
		}
	}
#line 120 "Utility/FsTabEntry.vala"
	result = list;
#line 120 "Utility/FsTabEntry.vala"
	lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
#line 120 "Utility/FsTabEntry.vala"
	_g_free0 (text);
#line 120 "Utility/FsTabEntry.vala"
	return result;
#line 760 "FsTabEntry.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 133 "Utility/FsTabEntry.vala"
	return self ? g_object_ref (self) : NULL;
#line 768 "FsTabEntry.c"
}

static gint
__lambda6_ (FsTabEntry* a,
            FsTabEntry* b)
{
	GCompareFunc _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gint result = 0;
#line 149 "Utility/FsTabEntry.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 149 "Utility/FsTabEntry.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 150 "Utility/FsTabEntry.vala"
	_tmp0_ = ((GCompareFunc) g_strcmp0);
#line 150 "Utility/FsTabEntry.vala"
	_tmp1_ = a->mount_point;
#line 150 "Utility/FsTabEntry.vala"
	_tmp2_ = b->mount_point;
#line 150 "Utility/FsTabEntry.vala"
	result = _tmp0_ (_tmp1_, _tmp2_);
#line 150 "Utility/FsTabEntry.vala"
	return result;
#line 793 "FsTabEntry.c"
}

static gint
___lambda6__gcompare_data_func (gconstpointer a,
                                gconstpointer b,
                                gpointer self)
{
	gint result;
	result = __lambda6_ ((FsTabEntry*) a, (FsTabEntry*) b);
#line 149 "Utility/FsTabEntry.vala"
	return result;
#line 805 "FsTabEntry.c"
}

gchar*
fs_tab_entry_write_file (GeeArrayList* entries,
                         const gchar* file_path,
                         gboolean keep_comments_and_empty_lines)
{
	gchar* text = NULL;
	gchar* _tmp0_;
	const gchar* _tmp34_;
	gchar* result = NULL;
#line 123 "Utility/FsTabEntry.vala"
	g_return_val_if_fail (entries != NULL, NULL);
#line 123 "Utility/FsTabEntry.vala"
	g_return_val_if_fail (file_path != NULL, NULL);
#line 127 "Utility/FsTabEntry.vala"
	_tmp0_ = g_strdup ("");
#line 127 "Utility/FsTabEntry.vala"
	text = _tmp0_;
#line 129 "Utility/FsTabEntry.vala"
	if (!keep_comments_and_empty_lines) {
#line 827 "FsTabEntry.c"
		const gchar* _tmp1_;
		gchar* _tmp2_;
#line 130 "Utility/FsTabEntry.vala"
		_tmp1_ = text;
#line 130 "Utility/FsTabEntry.vala"
		_tmp2_ = g_strconcat (_tmp1_, "# <file system> <mount point> <type> <options> <dump> <pass>\n\n", NULL);
#line 130 "Utility/FsTabEntry.vala"
		_g_free0 (text);
#line 130 "Utility/FsTabEntry.vala"
		text = _tmp2_;
#line 838 "FsTabEntry.c"
	}
	{
		GeeArrayList* _entry_list = NULL;
		GeeArrayList* _tmp3_;
		gint _entry_size = 0;
		GeeArrayList* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		gint _entry_index = 0;
#line 133 "Utility/FsTabEntry.vala"
		_tmp3_ = _g_object_ref0 (entries);
#line 133 "Utility/FsTabEntry.vala"
		_entry_list = _tmp3_;
#line 133 "Utility/FsTabEntry.vala"
		_tmp4_ = _entry_list;
#line 133 "Utility/FsTabEntry.vala"
		_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
#line 133 "Utility/FsTabEntry.vala"
		_tmp6_ = _tmp5_;
#line 133 "Utility/FsTabEntry.vala"
		_entry_size = _tmp6_;
#line 133 "Utility/FsTabEntry.vala"
		_entry_index = -1;
#line 133 "Utility/FsTabEntry.vala"
		while (TRUE) {
#line 864 "FsTabEntry.c"
			FsTabEntry* entry = NULL;
			GeeArrayList* _tmp7_;
			gpointer _tmp8_;
			gboolean _tmp9_ = FALSE;
			FsTabEntry* _tmp10_;
#line 133 "Utility/FsTabEntry.vala"
			_entry_index = _entry_index + 1;
#line 133 "Utility/FsTabEntry.vala"
			if (!(_entry_index < _entry_size)) {
#line 133 "Utility/FsTabEntry.vala"
				break;
#line 876 "FsTabEntry.c"
			}
#line 133 "Utility/FsTabEntry.vala"
			_tmp7_ = _entry_list;
#line 133 "Utility/FsTabEntry.vala"
			_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, _entry_index);
#line 133 "Utility/FsTabEntry.vala"
			entry = (FsTabEntry*) _tmp8_;
#line 134 "Utility/FsTabEntry.vala"
			_tmp10_ = entry;
#line 134 "Utility/FsTabEntry.vala"
			if (_tmp10_->is_comment) {
#line 134 "Utility/FsTabEntry.vala"
				_tmp9_ = TRUE;
#line 890 "FsTabEntry.c"
			} else {
				FsTabEntry* _tmp11_;
#line 134 "Utility/FsTabEntry.vala"
				_tmp11_ = entry;
#line 134 "Utility/FsTabEntry.vala"
				_tmp9_ = _tmp11_->is_empty_line;
#line 897 "FsTabEntry.c"
			}
#line 134 "Utility/FsTabEntry.vala"
			if (_tmp9_) {
#line 135 "Utility/FsTabEntry.vala"
				if (keep_comments_and_empty_lines) {
#line 903 "FsTabEntry.c"
					const gchar* _tmp12_;
					FsTabEntry* _tmp13_;
					const gchar* _tmp14_;
					gchar* _tmp15_;
					gchar* _tmp16_;
					gchar* _tmp17_;
#line 136 "Utility/FsTabEntry.vala"
					_tmp12_ = text;
#line 136 "Utility/FsTabEntry.vala"
					_tmp13_ = entry;
#line 136 "Utility/FsTabEntry.vala"
					_tmp14_ = _tmp13_->line;
#line 136 "Utility/FsTabEntry.vala"
					_tmp15_ = g_strdup_printf ("%s\n", _tmp14_);
#line 136 "Utility/FsTabEntry.vala"
					_tmp16_ = _tmp15_;
#line 136 "Utility/FsTabEntry.vala"
					_tmp17_ = g_strconcat (_tmp12_, _tmp16_, NULL);
#line 136 "Utility/FsTabEntry.vala"
					_g_free0 (text);
#line 136 "Utility/FsTabEntry.vala"
					text = _tmp17_;
#line 136 "Utility/FsTabEntry.vala"
					_g_free0 (_tmp16_);
#line 928 "FsTabEntry.c"
				}
			} else {
				const gchar* _tmp18_;
				FsTabEntry* _tmp19_;
				const gchar* _tmp20_;
				FsTabEntry* _tmp21_;
				const gchar* _tmp22_;
				FsTabEntry* _tmp23_;
				const gchar* _tmp24_;
				FsTabEntry* _tmp25_;
				const gchar* _tmp26_;
				FsTabEntry* _tmp27_;
				const gchar* _tmp28_;
				FsTabEntry* _tmp29_;
				const gchar* _tmp30_;
				gchar* _tmp31_;
				gchar* _tmp32_;
				gchar* _tmp33_;
#line 140 "Utility/FsTabEntry.vala"
				_tmp18_ = text;
#line 140 "Utility/FsTabEntry.vala"
				_tmp19_ = entry;
#line 140 "Utility/FsTabEntry.vala"
				_tmp20_ = _tmp19_->device_string;
#line 140 "Utility/FsTabEntry.vala"
				_tmp21_ = entry;
#line 140 "Utility/FsTabEntry.vala"
				_tmp22_ = _tmp21_->mount_point;
#line 140 "Utility/FsTabEntry.vala"
				_tmp23_ = entry;
#line 140 "Utility/FsTabEntry.vala"
				_tmp24_ = _tmp23_->type;
#line 140 "Utility/FsTabEntry.vala"
				_tmp25_ = entry;
#line 140 "Utility/FsTabEntry.vala"
				_tmp26_ = _tmp25_->options;
#line 140 "Utility/FsTabEntry.vala"
				_tmp27_ = entry;
#line 140 "Utility/FsTabEntry.vala"
				_tmp28_ = _tmp27_->dump;
#line 140 "Utility/FsTabEntry.vala"
				_tmp29_ = entry;
#line 140 "Utility/FsTabEntry.vala"
				_tmp30_ = _tmp29_->pass;
#line 140 "Utility/FsTabEntry.vala"
				_tmp31_ = g_strdup_printf ("%s\t%s\t%s\t%s\t%s\t%s\n", _tmp20_, _tmp22_, _tmp24_, _tmp26_, _tmp28_, _tmp30_);
#line 140 "Utility/FsTabEntry.vala"
				_tmp32_ = _tmp31_;
#line 140 "Utility/FsTabEntry.vala"
				_tmp33_ = g_strconcat (_tmp18_, _tmp32_, NULL);
#line 140 "Utility/FsTabEntry.vala"
				_g_free0 (text);
#line 140 "Utility/FsTabEntry.vala"
				text = _tmp33_;
#line 140 "Utility/FsTabEntry.vala"
				_g_free0 (_tmp32_);
#line 985 "FsTabEntry.c"
			}
#line 133 "Utility/FsTabEntry.vala"
			_g_object_unref0 (entry);
#line 989 "FsTabEntry.c"
		}
#line 133 "Utility/FsTabEntry.vala"
		_g_object_unref0 (_entry_list);
#line 993 "FsTabEntry.c"
	}
#line 149 "Utility/FsTabEntry.vala"
	gee_list_sort ((GeeList*) entries, ___lambda6__gcompare_data_func, NULL, NULL);
#line 153 "Utility/FsTabEntry.vala"
	if (tee_jee_file_system_file_exists (file_path)) {
#line 154 "Utility/FsTabEntry.vala"
		tee_jee_file_system_file_delete (file_path);
#line 1001 "FsTabEntry.c"
	}
#line 157 "Utility/FsTabEntry.vala"
	_tmp34_ = text;
#line 157 "Utility/FsTabEntry.vala"
	tee_jee_file_system_file_write (file_path, _tmp34_);
#line 159 "Utility/FsTabEntry.vala"
	result = text;
#line 159 "Utility/FsTabEntry.vala"
	return result;
#line 1011 "FsTabEntry.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result = FALSE;
#line 1478 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1478 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1479 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1479 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1479 "glib-2.0.vapi"
	return result;
#line 1030 "FsTabEntry.c"
}

gchar*
fs_tab_entry_subvolume_name (FsTabEntry* self)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_;
	gchar* result = NULL;
#line 162 "Utility/FsTabEntry.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 164 "Utility/FsTabEntry.vala"
	_tmp0_ = self->options;
#line 164 "Utility/FsTabEntry.vala"
	_tmp1_ = g_utf8_strdown (_tmp0_, (gssize) -1);
#line 164 "Utility/FsTabEntry.vala"
	_tmp2_ = _tmp1_;
#line 164 "Utility/FsTabEntry.vala"
	_tmp3_ = string_contains (_tmp2_, "subvol=");
#line 164 "Utility/FsTabEntry.vala"
	_g_free0 (_tmp2_);
#line 164 "Utility/FsTabEntry.vala"
	if (_tmp3_) {
#line 1055 "FsTabEntry.c"
		gchar* txt = NULL;
		const gchar* _tmp4_;
		gchar** _tmp5_;
		gchar** _tmp6_;
		gchar** _tmp7_;
		gint _tmp7__length1;
		const gchar* _tmp8_;
		gchar** _tmp9_;
		gchar** _tmp10_;
		gchar** _tmp11_;
		gint _tmp11__length1;
		const gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		gboolean _tmp15_ = FALSE;
		const gchar* _tmp16_;
#line 165 "Utility/FsTabEntry.vala"
		_tmp4_ = self->options;
#line 165 "Utility/FsTabEntry.vala"
		_tmp6_ = _tmp5_ = g_strsplit (_tmp4_, "subvol=", 0);
#line 165 "Utility/FsTabEntry.vala"
		_tmp7_ = _tmp6_;
#line 165 "Utility/FsTabEntry.vala"
		_tmp7__length1 = _vala_array_length (_tmp5_);
#line 165 "Utility/FsTabEntry.vala"
		_tmp8_ = _tmp7_[1];
#line 165 "Utility/FsTabEntry.vala"
		_tmp10_ = _tmp9_ = g_strsplit (_tmp8_, ",", 0);
#line 165 "Utility/FsTabEntry.vala"
		_tmp11_ = _tmp10_;
#line 165 "Utility/FsTabEntry.vala"
		_tmp11__length1 = _vala_array_length (_tmp9_);
#line 165 "Utility/FsTabEntry.vala"
		_tmp12_ = _tmp11_[0];
#line 165 "Utility/FsTabEntry.vala"
		_tmp13_ = string_strip (_tmp12_);
#line 165 "Utility/FsTabEntry.vala"
		_tmp14_ = _tmp13_;
#line 165 "Utility/FsTabEntry.vala"
		_tmp11_ = (_vala_array_free (_tmp11_, _tmp11__length1, (GDestroyNotify) g_free), NULL);
#line 165 "Utility/FsTabEntry.vala"
		_tmp7_ = (_vala_array_free (_tmp7_, _tmp7__length1, (GDestroyNotify) g_free), NULL);
#line 165 "Utility/FsTabEntry.vala"
		txt = _tmp14_;
#line 166 "Utility/FsTabEntry.vala"
		_tmp16_ = txt;
#line 166 "Utility/FsTabEntry.vala"
		if (g_str_has_prefix (_tmp16_, "/")) {
#line 1104 "FsTabEntry.c"
			const gchar* _tmp17_;
			gchar** _tmp18_;
			gchar** _tmp19_;
			gchar** _tmp20_;
			gint _tmp20__length1;
#line 166 "Utility/FsTabEntry.vala"
			_tmp17_ = txt;
#line 166 "Utility/FsTabEntry.vala"
			_tmp19_ = _tmp18_ = g_strsplit (_tmp17_, "/", 0);
#line 166 "Utility/FsTabEntry.vala"
			_tmp20_ = _tmp19_;
#line 166 "Utility/FsTabEntry.vala"
			_tmp20__length1 = _vala_array_length (_tmp18_);
#line 166 "Utility/FsTabEntry.vala"
			_tmp15_ = _vala_array_length (_tmp18_) == 2;
#line 166 "Utility/FsTabEntry.vala"
			_tmp20_ = (_vala_array_free (_tmp20_, _tmp20__length1, (GDestroyNotify) g_free), NULL);
#line 1122 "FsTabEntry.c"
		} else {
#line 166 "Utility/FsTabEntry.vala"
			_tmp15_ = FALSE;
#line 1126 "FsTabEntry.c"
		}
#line 166 "Utility/FsTabEntry.vala"
		if (_tmp15_) {
#line 1130 "FsTabEntry.c"
			const gchar* _tmp21_;
			gchar** _tmp22_;
			gchar** _tmp23_;
			gchar** _tmp24_;
			gint _tmp24__length1;
			const gchar* _tmp25_;
			gchar* _tmp26_;
#line 167 "Utility/FsTabEntry.vala"
			_tmp21_ = txt;
#line 167 "Utility/FsTabEntry.vala"
			_tmp23_ = _tmp22_ = g_strsplit (_tmp21_, "/", 0);
#line 167 "Utility/FsTabEntry.vala"
			_tmp24_ = _tmp23_;
#line 167 "Utility/FsTabEntry.vala"
			_tmp24__length1 = _vala_array_length (_tmp22_);
#line 167 "Utility/FsTabEntry.vala"
			_tmp25_ = _tmp24_[1];
#line 167 "Utility/FsTabEntry.vala"
			_tmp26_ = g_strdup (_tmp25_);
#line 167 "Utility/FsTabEntry.vala"
			_g_free0 (txt);
#line 167 "Utility/FsTabEntry.vala"
			txt = _tmp26_;
#line 167 "Utility/FsTabEntry.vala"
			_tmp24_ = (_vala_array_free (_tmp24_, _tmp24__length1, (GDestroyNotify) g_free), NULL);
#line 1156 "FsTabEntry.c"
		}
#line 169 "Utility/FsTabEntry.vala"
		result = txt;
#line 169 "Utility/FsTabEntry.vala"
		return result;
#line 1162 "FsTabEntry.c"
	} else {
		gchar* _tmp27_;
#line 172 "Utility/FsTabEntry.vala"
		_tmp27_ = g_strdup ("");
#line 172 "Utility/FsTabEntry.vala"
		result = _tmp27_;
#line 172 "Utility/FsTabEntry.vala"
		return result;
#line 1171 "FsTabEntry.c"
	}
}

gboolean
fs_tab_entry_is_for_system_directory (FsTabEntry* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	const gchar* _tmp7_;
	gboolean result = FALSE;
#line 176 "Utility/FsTabEntry.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 178 "Utility/FsTabEntry.vala"
	_tmp7_ = self->mount_point;
#line 178 "Utility/FsTabEntry.vala"
	if (g_str_has_prefix (_tmp7_, "/mnt")) {
#line 178 "Utility/FsTabEntry.vala"
		_tmp6_ = TRUE;
#line 1195 "FsTabEntry.c"
	} else {
		const gchar* _tmp8_;
#line 179 "Utility/FsTabEntry.vala"
		_tmp8_ = self->mount_point;
#line 179 "Utility/FsTabEntry.vala"
		_tmp6_ = g_str_has_prefix (_tmp8_, "/mount");
#line 1202 "FsTabEntry.c"
	}
#line 178 "Utility/FsTabEntry.vala"
	if (_tmp6_) {
#line 178 "Utility/FsTabEntry.vala"
		_tmp5_ = TRUE;
#line 1208 "FsTabEntry.c"
	} else {
		const gchar* _tmp9_;
#line 180 "Utility/FsTabEntry.vala"
		_tmp9_ = self->mount_point;
#line 180 "Utility/FsTabEntry.vala"
		_tmp5_ = g_str_has_prefix (_tmp9_, "/sdcard");
#line 1215 "FsTabEntry.c"
	}
#line 178 "Utility/FsTabEntry.vala"
	if (_tmp5_) {
#line 178 "Utility/FsTabEntry.vala"
		_tmp4_ = TRUE;
#line 1221 "FsTabEntry.c"
	} else {
		const gchar* _tmp10_;
#line 181 "Utility/FsTabEntry.vala"
		_tmp10_ = self->mount_point;
#line 181 "Utility/FsTabEntry.vala"
		_tmp4_ = g_str_has_prefix (_tmp10_, "/cdrom");
#line 1228 "FsTabEntry.c"
	}
#line 178 "Utility/FsTabEntry.vala"
	if (_tmp4_) {
#line 178 "Utility/FsTabEntry.vala"
		_tmp3_ = TRUE;
#line 1234 "FsTabEntry.c"
	} else {
		const gchar* _tmp11_;
#line 182 "Utility/FsTabEntry.vala"
		_tmp11_ = self->mount_point;
#line 182 "Utility/FsTabEntry.vala"
		_tmp3_ = g_str_has_prefix (_tmp11_, "/media");
#line 1241 "FsTabEntry.c"
	}
#line 178 "Utility/FsTabEntry.vala"
	if (_tmp3_) {
#line 178 "Utility/FsTabEntry.vala"
		_tmp2_ = TRUE;
#line 1247 "FsTabEntry.c"
	} else {
		const gchar* _tmp12_;
#line 183 "Utility/FsTabEntry.vala"
		_tmp12_ = self->mount_point;
#line 183 "Utility/FsTabEntry.vala"
		_tmp2_ = g_strcmp0 (_tmp12_, "none") == 0;
#line 1254 "FsTabEntry.c"
	}
#line 178 "Utility/FsTabEntry.vala"
	if (_tmp2_) {
#line 178 "Utility/FsTabEntry.vala"
		_tmp1_ = TRUE;
#line 1260 "FsTabEntry.c"
	} else {
		const gchar* _tmp13_;
#line 184 "Utility/FsTabEntry.vala"
		_tmp13_ = self->mount_point;
#line 184 "Utility/FsTabEntry.vala"
		_tmp1_ = !g_str_has_prefix (_tmp13_, "/");
#line 1267 "FsTabEntry.c"
	}
#line 178 "Utility/FsTabEntry.vala"
	if (_tmp1_) {
#line 178 "Utility/FsTabEntry.vala"
		_tmp0_ = TRUE;
#line 1273 "FsTabEntry.c"
	} else {
		gboolean _tmp14_ = FALSE;
		const gchar* _tmp15_;
#line 185 "Utility/FsTabEntry.vala"
		_tmp15_ = self->device_string;
#line 185 "Utility/FsTabEntry.vala"
		if (!g_str_has_prefix (_tmp15_, "/dev/")) {
#line 1281 "FsTabEntry.c"
			const gchar* _tmp16_;
			gchar* _tmp17_;
			gchar* _tmp18_;
#line 185 "Utility/FsTabEntry.vala"
			_tmp16_ = self->device_string;
#line 185 "Utility/FsTabEntry.vala"
			_tmp17_ = g_utf8_strdown (_tmp16_, (gssize) -1);
#line 185 "Utility/FsTabEntry.vala"
			_tmp18_ = _tmp17_;
#line 185 "Utility/FsTabEntry.vala"
			_tmp14_ = !g_str_has_prefix (_tmp18_, "uuid=");
#line 185 "Utility/FsTabEntry.vala"
			_g_free0 (_tmp18_);
#line 1295 "FsTabEntry.c"
		} else {
#line 185 "Utility/FsTabEntry.vala"
			_tmp14_ = FALSE;
#line 1299 "FsTabEntry.c"
		}
#line 185 "Utility/FsTabEntry.vala"
		_tmp0_ = _tmp14_;
#line 1303 "FsTabEntry.c"
	}
#line 178 "Utility/FsTabEntry.vala"
	if (_tmp0_) {
#line 187 "Utility/FsTabEntry.vala"
		result = FALSE;
#line 187 "Utility/FsTabEntry.vala"
		return result;
#line 1311 "FsTabEntry.c"
	} else {
#line 190 "Utility/FsTabEntry.vala"
		result = TRUE;
#line 190 "Utility/FsTabEntry.vala"
		return result;
#line 1317 "FsTabEntry.c"
	}
}

FsTabEntry*
fs_tab_entry_find_entry_by_mount_point (GeeArrayList* entries,
                                        const gchar* mount_path)
{
	FsTabEntry* result = NULL;
#line 194 "Utility/FsTabEntry.vala"
	g_return_val_if_fail (entries != NULL, NULL);
#line 194 "Utility/FsTabEntry.vala"
	g_return_val_if_fail (mount_path != NULL, NULL);
#line 1330 "FsTabEntry.c"
	{
		GeeArrayList* _entry_list = NULL;
		GeeArrayList* _tmp0_;
		gint _entry_size = 0;
		GeeArrayList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _entry_index = 0;
#line 197 "Utility/FsTabEntry.vala"
		_tmp0_ = _g_object_ref0 (entries);
#line 197 "Utility/FsTabEntry.vala"
		_entry_list = _tmp0_;
#line 197 "Utility/FsTabEntry.vala"
		_tmp1_ = _entry_list;
#line 197 "Utility/FsTabEntry.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 197 "Utility/FsTabEntry.vala"
		_tmp3_ = _tmp2_;
#line 197 "Utility/FsTabEntry.vala"
		_entry_size = _tmp3_;
#line 197 "Utility/FsTabEntry.vala"
		_entry_index = -1;
#line 197 "Utility/FsTabEntry.vala"
		while (TRUE) {
#line 1355 "FsTabEntry.c"
			FsTabEntry* entry = NULL;
			GeeArrayList* _tmp4_;
			gpointer _tmp5_;
			FsTabEntry* _tmp6_;
			const gchar* _tmp7_;
#line 197 "Utility/FsTabEntry.vala"
			_entry_index = _entry_index + 1;
#line 197 "Utility/FsTabEntry.vala"
			if (!(_entry_index < _entry_size)) {
#line 197 "Utility/FsTabEntry.vala"
				break;
#line 1367 "FsTabEntry.c"
			}
#line 197 "Utility/FsTabEntry.vala"
			_tmp4_ = _entry_list;
#line 197 "Utility/FsTabEntry.vala"
			_tmp5_ = gee_abstract_list_get ((GeeAbstractList*) _tmp4_, _entry_index);
#line 197 "Utility/FsTabEntry.vala"
			entry = (FsTabEntry*) _tmp5_;
#line 198 "Utility/FsTabEntry.vala"
			_tmp6_ = entry;
#line 198 "Utility/FsTabEntry.vala"
			_tmp7_ = _tmp6_->mount_point;
#line 198 "Utility/FsTabEntry.vala"
			if (g_strcmp0 (_tmp7_, mount_path) == 0) {
#line 199 "Utility/FsTabEntry.vala"
				result = entry;
#line 199 "Utility/FsTabEntry.vala"
				_g_object_unref0 (_entry_list);
#line 199 "Utility/FsTabEntry.vala"
				return result;
#line 1387 "FsTabEntry.c"
			}
#line 197 "Utility/FsTabEntry.vala"
			_g_object_unref0 (entry);
#line 1391 "FsTabEntry.c"
		}
#line 197 "Utility/FsTabEntry.vala"
		_g_object_unref0 (_entry_list);
#line 1395 "FsTabEntry.c"
	}
#line 202 "Utility/FsTabEntry.vala"
	result = NULL;
#line 202 "Utility/FsTabEntry.vala"
	return result;
#line 1401 "FsTabEntry.c"
}

Device*
fs_tab_entry_resolve_device (FsTabEntry* self,
                             GeeArrayList* crypttab,
                             GtkWindow* parent_window)
{
	Device* dev_fstab = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gboolean _tmp5_;
	Device* _tmp12_;
	Device* result = NULL;
#line 205 "Utility/FsTabEntry.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 205 "Utility/FsTabEntry.vala"
	g_return_val_if_fail (crypttab != NULL, NULL);
#line 206 "Utility/FsTabEntry.vala"
	dev_fstab = NULL;
#line 207 "Utility/FsTabEntry.vala"
	_tmp0_ = fs_tab_entry_get_device_uuid (self);
#line 207 "Utility/FsTabEntry.vala"
	_tmp1_ = _tmp0_;
#line 207 "Utility/FsTabEntry.vala"
	_tmp2_ = _tmp1_;
#line 207 "Utility/FsTabEntry.vala"
	_tmp3_ = strlen (_tmp2_);
#line 207 "Utility/FsTabEntry.vala"
	_tmp4_ = _tmp3_;
#line 207 "Utility/FsTabEntry.vala"
	_tmp5_ = _tmp4_ > 0;
#line 207 "Utility/FsTabEntry.vala"
	_g_free0 (_tmp2_);
#line 207 "Utility/FsTabEntry.vala"
	if (_tmp5_) {
#line 1440 "FsTabEntry.c"
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		Device* _tmp9_;
#line 208 "Utility/FsTabEntry.vala"
		_tmp6_ = fs_tab_entry_get_device_uuid (self);
#line 208 "Utility/FsTabEntry.vala"
		_tmp7_ = _tmp6_;
#line 208 "Utility/FsTabEntry.vala"
		_tmp8_ = _tmp7_;
#line 208 "Utility/FsTabEntry.vala"
		_tmp9_ = device_get_device_by_uuid (_tmp8_);
#line 208 "Utility/FsTabEntry.vala"
		_g_object_unref0 (dev_fstab);
#line 208 "Utility/FsTabEntry.vala"
		dev_fstab = _tmp9_;
#line 208 "Utility/FsTabEntry.vala"
		_g_free0 (_tmp8_);
#line 1459 "FsTabEntry.c"
	} else {
		const gchar* _tmp10_;
		Device* _tmp11_;
#line 211 "Utility/FsTabEntry.vala"
		_tmp10_ = self->device_string;
#line 211 "Utility/FsTabEntry.vala"
		_tmp11_ = device_get_device_by_name (_tmp10_);
#line 211 "Utility/FsTabEntry.vala"
		_g_object_unref0 (dev_fstab);
#line 211 "Utility/FsTabEntry.vala"
		dev_fstab = _tmp11_;
#line 1471 "FsTabEntry.c"
	}
#line 214 "Utility/FsTabEntry.vala"
	_tmp12_ = dev_fstab;
#line 214 "Utility/FsTabEntry.vala"
	if (_tmp12_ == NULL) {
#line 1477 "FsTabEntry.c"
		const gchar* _tmp13_;
#line 226 "Utility/FsTabEntry.vala"
		_tmp13_ = self->device_string;
#line 226 "Utility/FsTabEntry.vala"
		if (g_str_has_prefix (_tmp13_, "/dev/mapper/")) {
#line 1483 "FsTabEntry.c"
			gchar* mapped_name = NULL;
			const gchar* _tmp14_;
			gchar* _tmp15_;
#line 228 "Utility/FsTabEntry.vala"
			_tmp14_ = self->device_string;
#line 228 "Utility/FsTabEntry.vala"
			_tmp15_ = string_replace (_tmp14_, "/dev/mapper/", "");
#line 228 "Utility/FsTabEntry.vala"
			mapped_name = _tmp15_;
#line 1493 "FsTabEntry.c"
			{
				GeeArrayList* _item_list = NULL;
				GeeArrayList* _tmp16_;
				gint _item_size = 0;
				GeeArrayList* _tmp17_;
				gint _tmp18_;
				gint _tmp19_;
				gint _item_index = 0;
#line 230 "Utility/FsTabEntry.vala"
				_tmp16_ = _g_object_ref0 (crypttab);
#line 230 "Utility/FsTabEntry.vala"
				_item_list = _tmp16_;
#line 230 "Utility/FsTabEntry.vala"
				_tmp17_ = _item_list;
#line 230 "Utility/FsTabEntry.vala"
				_tmp18_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp17_);
#line 230 "Utility/FsTabEntry.vala"
				_tmp19_ = _tmp18_;
#line 230 "Utility/FsTabEntry.vala"
				_item_size = _tmp19_;
#line 230 "Utility/FsTabEntry.vala"
				_item_index = -1;
#line 230 "Utility/FsTabEntry.vala"
				while (TRUE) {
#line 1518 "FsTabEntry.c"
					CryptTabEntry* item = NULL;
					GeeArrayList* _tmp20_;
					gpointer _tmp21_;
					CryptTabEntry* _tmp22_;
					const gchar* _tmp23_;
					const gchar* _tmp24_;
#line 230 "Utility/FsTabEntry.vala"
					_item_index = _item_index + 1;
#line 230 "Utility/FsTabEntry.vala"
					if (!(_item_index < _item_size)) {
#line 230 "Utility/FsTabEntry.vala"
						break;
#line 1531 "FsTabEntry.c"
					}
#line 230 "Utility/FsTabEntry.vala"
					_tmp20_ = _item_list;
#line 230 "Utility/FsTabEntry.vala"
					_tmp21_ = gee_abstract_list_get ((GeeAbstractList*) _tmp20_, _item_index);
#line 230 "Utility/FsTabEntry.vala"
					item = (CryptTabEntry*) _tmp21_;
#line 232 "Utility/FsTabEntry.vala"
					_tmp22_ = item;
#line 232 "Utility/FsTabEntry.vala"
					_tmp23_ = _tmp22_->mapped_name;
#line 232 "Utility/FsTabEntry.vala"
					_tmp24_ = mapped_name;
#line 232 "Utility/FsTabEntry.vala"
					if (g_strcmp0 (_tmp23_, _tmp24_) == 0) {
#line 1547 "FsTabEntry.c"
						CryptTabEntry* _tmp25_;
						const gchar* _tmp26_;
						gchar* _tmp27_;
						gchar* _tmp28_;
						gchar* _tmp29_;
						gchar* _tmp30_;
						gint _tmp31_;
						gint _tmp32_;
						gboolean _tmp33_;
#line 235 "Utility/FsTabEntry.vala"
						_tmp25_ = item;
#line 235 "Utility/FsTabEntry.vala"
						_tmp26_ = _tmp25_->device_string;
#line 235 "Utility/FsTabEntry.vala"
						_tmp27_ = g_strdup (_tmp26_);
#line 235 "Utility/FsTabEntry.vala"
						_g_free0 (self->device_string);
#line 235 "Utility/FsTabEntry.vala"
						self->device_string = _tmp27_;
#line 237 "Utility/FsTabEntry.vala"
						_tmp28_ = fs_tab_entry_get_device_uuid (self);
#line 237 "Utility/FsTabEntry.vala"
						_tmp29_ = _tmp28_;
#line 237 "Utility/FsTabEntry.vala"
						_tmp30_ = _tmp29_;
#line 237 "Utility/FsTabEntry.vala"
						_tmp31_ = strlen (_tmp30_);
#line 237 "Utility/FsTabEntry.vala"
						_tmp32_ = _tmp31_;
#line 237 "Utility/FsTabEntry.vala"
						_tmp33_ = _tmp32_ > 0;
#line 237 "Utility/FsTabEntry.vala"
						_g_free0 (_tmp30_);
#line 237 "Utility/FsTabEntry.vala"
						if (_tmp33_) {
#line 1583 "FsTabEntry.c"
							Device* dev_luks = NULL;
							gchar* _tmp34_;
							gchar* _tmp35_;
							gchar* _tmp36_;
							Device* _tmp37_;
							Device* _tmp38_;
							Device* _tmp39_;
#line 240 "Utility/FsTabEntry.vala"
							_tmp34_ = fs_tab_entry_get_device_uuid (self);
#line 240 "Utility/FsTabEntry.vala"
							_tmp35_ = _tmp34_;
#line 240 "Utility/FsTabEntry.vala"
							_tmp36_ = _tmp35_;
#line 240 "Utility/FsTabEntry.vala"
							_tmp37_ = device_get_device_by_uuid (_tmp36_);
#line 240 "Utility/FsTabEntry.vala"
							_tmp38_ = _tmp37_;
#line 240 "Utility/FsTabEntry.vala"
							_g_free0 (_tmp36_);
#line 240 "Utility/FsTabEntry.vala"
							dev_luks = _tmp38_;
#line 242 "Utility/FsTabEntry.vala"
							_tmp39_ = dev_luks;
#line 242 "Utility/FsTabEntry.vala"
							if (_tmp39_ != NULL) {
#line 1609 "FsTabEntry.c"
								gchar* msg_out = NULL;
								gchar* msg_err = NULL;
								Device* dev_unlocked = NULL;
								Device* _tmp40_;
								gchar* _tmp41_ = NULL;
								gchar* _tmp42_ = NULL;
								Device* _tmp43_;
								Device* _tmp44_;
#line 245 "Utility/FsTabEntry.vala"
								_tmp40_ = dev_luks;
#line 245 "Utility/FsTabEntry.vala"
								_tmp43_ = device_luks_unlock (_tmp40_, "", "", parent_window, &_tmp41_, &_tmp42_);
#line 245 "Utility/FsTabEntry.vala"
								_g_free0 (msg_out);
#line 245 "Utility/FsTabEntry.vala"
								msg_out = _tmp41_;
#line 245 "Utility/FsTabEntry.vala"
								_g_free0 (msg_err);
#line 245 "Utility/FsTabEntry.vala"
								msg_err = _tmp42_;
#line 245 "Utility/FsTabEntry.vala"
								dev_unlocked = _tmp43_;
#line 248 "Utility/FsTabEntry.vala"
								_tmp44_ = dev_unlocked;
#line 248 "Utility/FsTabEntry.vala"
								if (_tmp44_ != NULL) {
#line 1636 "FsTabEntry.c"
									Device* _tmp45_;
									Device* _tmp46_;
#line 249 "Utility/FsTabEntry.vala"
									_tmp45_ = dev_unlocked;
#line 249 "Utility/FsTabEntry.vala"
									_tmp46_ = _g_object_ref0 (_tmp45_);
#line 249 "Utility/FsTabEntry.vala"
									_g_object_unref0 (dev_fstab);
#line 249 "Utility/FsTabEntry.vala"
									dev_fstab = _tmp46_;
#line 1647 "FsTabEntry.c"
								} else {
									Device* _tmp47_;
									Device* _tmp48_;
#line 252 "Utility/FsTabEntry.vala"
									_tmp47_ = dev_luks;
#line 252 "Utility/FsTabEntry.vala"
									_tmp48_ = _g_object_ref0 (_tmp47_);
#line 252 "Utility/FsTabEntry.vala"
									_g_object_unref0 (dev_fstab);
#line 252 "Utility/FsTabEntry.vala"
									dev_fstab = _tmp48_;
#line 1659 "FsTabEntry.c"
								}
#line 242 "Utility/FsTabEntry.vala"
								_g_object_unref0 (dev_unlocked);
#line 242 "Utility/FsTabEntry.vala"
								_g_free0 (msg_err);
#line 242 "Utility/FsTabEntry.vala"
								_g_free0 (msg_out);
#line 1667 "FsTabEntry.c"
							}
#line 237 "Utility/FsTabEntry.vala"
							_g_object_unref0 (dev_luks);
#line 1671 "FsTabEntry.c"
						} else {
						}
#line 260 "Utility/FsTabEntry.vala"
						_g_object_unref0 (item);
#line 260 "Utility/FsTabEntry.vala"
						break;
#line 1678 "FsTabEntry.c"
					}
#line 230 "Utility/FsTabEntry.vala"
					_g_object_unref0 (item);
#line 1682 "FsTabEntry.c"
				}
#line 230 "Utility/FsTabEntry.vala"
				_g_object_unref0 (_item_list);
#line 1686 "FsTabEntry.c"
			}
#line 226 "Utility/FsTabEntry.vala"
			_g_free0 (mapped_name);
#line 1690 "FsTabEntry.c"
		}
	}
#line 266 "Utility/FsTabEntry.vala"
	result = dev_fstab;
#line 266 "Utility/FsTabEntry.vala"
	return result;
#line 1697 "FsTabEntry.c"
}

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result = NULL;
#line 1428 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1429 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1429 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1429 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1430 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 1431 "glib-2.0.vapi"
		start = string_length + start;
#line 1724 "FsTabEntry.c"
	}
#line 1433 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 1434 "glib-2.0.vapi"
		end = string_length + end;
#line 1730 "FsTabEntry.c"
	}
#line 1436 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 1436 "glib-2.0.vapi"
		_tmp2_ = start <= string_length;
#line 1736 "FsTabEntry.c"
	} else {
#line 1436 "glib-2.0.vapi"
		_tmp2_ = FALSE;
#line 1740 "FsTabEntry.c"
	}
#line 1436 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp2_, NULL);
#line 1437 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 1437 "glib-2.0.vapi"
		_tmp3_ = end <= string_length;
#line 1748 "FsTabEntry.c"
	} else {
#line 1437 "glib-2.0.vapi"
		_tmp3_ = FALSE;
#line 1752 "FsTabEntry.c"
	}
#line 1437 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp3_, NULL);
#line 1438 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1439 "glib-2.0.vapi"
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1439 "glib-2.0.vapi"
	result = _tmp4_;
#line 1439 "glib-2.0.vapi"
	return result;
#line 1764 "FsTabEntry.c"
}

void
fs_tab_entry_append_option (FsTabEntry* self,
                            const gchar* option)
{
	const gchar* _tmp0_;
	const gchar* _tmp5_;
	const gchar* _tmp11_;
	gchar* _tmp12_;
#line 270 "Utility/FsTabEntry.vala"
	g_return_if_fail (self != NULL);
#line 270 "Utility/FsTabEntry.vala"
	g_return_if_fail (option != NULL);
#line 272 "Utility/FsTabEntry.vala"
	_tmp0_ = self->options;
#line 272 "Utility/FsTabEntry.vala"
	if (!string_contains (_tmp0_, option)) {
#line 1783 "FsTabEntry.c"
		const gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
#line 273 "Utility/FsTabEntry.vala"
		_tmp1_ = self->options;
#line 273 "Utility/FsTabEntry.vala"
		_tmp2_ = g_strdup_printf (",%s", option);
#line 273 "Utility/FsTabEntry.vala"
		_tmp3_ = _tmp2_;
#line 273 "Utility/FsTabEntry.vala"
		_tmp4_ = g_strconcat (_tmp1_, _tmp3_, NULL);
#line 273 "Utility/FsTabEntry.vala"
		_g_free0 (self->options);
#line 273 "Utility/FsTabEntry.vala"
		self->options = _tmp4_;
#line 273 "Utility/FsTabEntry.vala"
		_g_free0 (_tmp3_);
#line 1802 "FsTabEntry.c"
	}
#line 276 "Utility/FsTabEntry.vala"
	_tmp5_ = self->options;
#line 276 "Utility/FsTabEntry.vala"
	if (g_str_has_prefix (_tmp5_, ",")) {
#line 1808 "FsTabEntry.c"
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		gint _tmp8_;
		gint _tmp9_;
		gchar* _tmp10_;
#line 277 "Utility/FsTabEntry.vala"
		_tmp6_ = self->options;
#line 277 "Utility/FsTabEntry.vala"
		_tmp7_ = self->options;
#line 277 "Utility/FsTabEntry.vala"
		_tmp8_ = strlen (_tmp7_);
#line 277 "Utility/FsTabEntry.vala"
		_tmp9_ = _tmp8_;
#line 277 "Utility/FsTabEntry.vala"
		_tmp10_ = string_slice (_tmp6_, (glong) 1, (glong) _tmp9_);
#line 277 "Utility/FsTabEntry.vala"
		_g_free0 (self->options);
#line 277 "Utility/FsTabEntry.vala"
		self->options = _tmp10_;
#line 1828 "FsTabEntry.c"
	}
#line 280 "Utility/FsTabEntry.vala"
	_tmp11_ = self->options;
#line 280 "Utility/FsTabEntry.vala"
	_tmp12_ = string_strip (_tmp11_);
#line 280 "Utility/FsTabEntry.vala"
	_g_free0 (self->options);
#line 280 "Utility/FsTabEntry.vala"
	self->options = _tmp12_;
#line 1838 "FsTabEntry.c"
}

void
fs_tab_entry_remove_option (FsTabEntry* self,
                            const gchar* option)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp10_;
	const gchar* _tmp16_;
	gchar* _tmp17_;
#line 283 "Utility/FsTabEntry.vala"
	g_return_if_fail (self != NULL);
#line 283 "Utility/FsTabEntry.vala"
	g_return_if_fail (option != NULL);
#line 285 "Utility/FsTabEntry.vala"
	_tmp0_ = self->options;
#line 285 "Utility/FsTabEntry.vala"
	_tmp1_ = string_replace (_tmp0_, option, "");
#line 285 "Utility/FsTabEntry.vala"
	_tmp2_ = _tmp1_;
#line 285 "Utility/FsTabEntry.vala"
	_tmp3_ = string_strip (_tmp2_);
#line 285 "Utility/FsTabEntry.vala"
	_g_free0 (self->options);
#line 285 "Utility/FsTabEntry.vala"
	self->options = _tmp3_;
#line 285 "Utility/FsTabEntry.vala"
	_g_free0 (_tmp2_);
#line 287 "Utility/FsTabEntry.vala"
	_tmp4_ = self->options;
#line 287 "Utility/FsTabEntry.vala"
	if (g_str_has_prefix (_tmp4_, ",")) {
#line 1875 "FsTabEntry.c"
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
		gchar* _tmp9_;
#line 288 "Utility/FsTabEntry.vala"
		_tmp5_ = self->options;
#line 288 "Utility/FsTabEntry.vala"
		_tmp6_ = self->options;
#line 288 "Utility/FsTabEntry.vala"
		_tmp7_ = strlen (_tmp6_);
#line 288 "Utility/FsTabEntry.vala"
		_tmp8_ = _tmp7_;
#line 288 "Utility/FsTabEntry.vala"
		_tmp9_ = string_slice (_tmp5_, (glong) 1, (glong) _tmp8_);
#line 288 "Utility/FsTabEntry.vala"
		_g_free0 (self->options);
#line 288 "Utility/FsTabEntry.vala"
		self->options = _tmp9_;
#line 1895 "FsTabEntry.c"
	}
#line 291 "Utility/FsTabEntry.vala"
	_tmp10_ = self->options;
#line 291 "Utility/FsTabEntry.vala"
	if (g_str_has_suffix (_tmp10_, ",")) {
#line 1901 "FsTabEntry.c"
		const gchar* _tmp11_;
		const gchar* _tmp12_;
		gint _tmp13_;
		gint _tmp14_;
		gchar* _tmp15_;
#line 292 "Utility/FsTabEntry.vala"
		_tmp11_ = self->options;
#line 292 "Utility/FsTabEntry.vala"
		_tmp12_ = self->options;
#line 292 "Utility/FsTabEntry.vala"
		_tmp13_ = strlen (_tmp12_);
#line 292 "Utility/FsTabEntry.vala"
		_tmp14_ = _tmp13_;
#line 292 "Utility/FsTabEntry.vala"
		_tmp15_ = string_slice (_tmp11_, (glong) 0, (glong) (_tmp14_ - 1));
#line 292 "Utility/FsTabEntry.vala"
		_g_free0 (self->options);
#line 292 "Utility/FsTabEntry.vala"
		self->options = _tmp15_;
#line 1921 "FsTabEntry.c"
	}
#line 295 "Utility/FsTabEntry.vala"
	_tmp16_ = self->options;
#line 295 "Utility/FsTabEntry.vala"
	_tmp17_ = string_strip (_tmp16_);
#line 295 "Utility/FsTabEntry.vala"
	_g_free0 (self->options);
#line 295 "Utility/FsTabEntry.vala"
	self->options = _tmp17_;
#line 1931 "FsTabEntry.c"
}

FsTabEntry*
fs_tab_entry_construct (GType object_type)
{
	FsTabEntry * self = NULL;
#line 32 "Utility/FsTabEntry.vala"
	self = (FsTabEntry*) g_object_new (object_type, NULL);
#line 32 "Utility/FsTabEntry.vala"
	return self;
#line 1942 "FsTabEntry.c"
}

FsTabEntry*
fs_tab_entry_new (void)
{
#line 32 "Utility/FsTabEntry.vala"
	return fs_tab_entry_construct (TYPE_FS_TAB_ENTRY);
#line 1950 "FsTabEntry.c"
}

gchar*
fs_tab_entry_get_device_uuid (FsTabEntry* self)
{
	gchar* result;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_;
#line 46 "Utility/FsTabEntry.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 47 "Utility/FsTabEntry.vala"
	_tmp0_ = self->device_string;
#line 47 "Utility/FsTabEntry.vala"
	_tmp1_ = g_utf8_strdown (_tmp0_, (gssize) -1);
#line 47 "Utility/FsTabEntry.vala"
	_tmp2_ = _tmp1_;
#line 47 "Utility/FsTabEntry.vala"
	_tmp3_ = g_str_has_prefix (_tmp2_, "uuid=");
#line 47 "Utility/FsTabEntry.vala"
	_g_free0 (_tmp2_);
#line 47 "Utility/FsTabEntry.vala"
	if (_tmp3_) {
#line 1975 "FsTabEntry.c"
		const gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar** _tmp9_;
		gchar** _tmp10_;
		gchar** _tmp11_;
		gint _tmp11__length1;
		const gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
#line 48 "Utility/FsTabEntry.vala"
		_tmp4_ = self->device_string;
#line 48 "Utility/FsTabEntry.vala"
		_tmp5_ = string_replace (_tmp4_, "\"", "");
#line 48 "Utility/FsTabEntry.vala"
		_tmp6_ = _tmp5_;
#line 48 "Utility/FsTabEntry.vala"
		_tmp7_ = string_replace (_tmp6_, "'", "");
#line 48 "Utility/FsTabEntry.vala"
		_tmp8_ = _tmp7_;
#line 48 "Utility/FsTabEntry.vala"
		_tmp10_ = _tmp9_ = g_strsplit (_tmp8_, "=", 0);
#line 48 "Utility/FsTabEntry.vala"
		_tmp11_ = _tmp10_;
#line 48 "Utility/FsTabEntry.vala"
		_tmp11__length1 = _vala_array_length (_tmp9_);
#line 48 "Utility/FsTabEntry.vala"
		_tmp12_ = _tmp11_[1];
#line 48 "Utility/FsTabEntry.vala"
		_tmp13_ = g_strdup (_tmp12_);
#line 48 "Utility/FsTabEntry.vala"
		_tmp14_ = _tmp13_;
#line 48 "Utility/FsTabEntry.vala"
		_tmp11_ = (_vala_array_free (_tmp11_, _tmp11__length1, (GDestroyNotify) g_free), NULL);
#line 48 "Utility/FsTabEntry.vala"
		_g_free0 (_tmp8_);
#line 48 "Utility/FsTabEntry.vala"
		_g_free0 (_tmp6_);
#line 48 "Utility/FsTabEntry.vala"
		result = _tmp14_;
#line 48 "Utility/FsTabEntry.vala"
		return result;
#line 2020 "FsTabEntry.c"
	} else {
		gchar* _tmp15_;
#line 51 "Utility/FsTabEntry.vala"
		_tmp15_ = g_strdup ("");
#line 51 "Utility/FsTabEntry.vala"
		result = _tmp15_;
#line 51 "Utility/FsTabEntry.vala"
		return result;
#line 2029 "FsTabEntry.c"
	}
}

void
fs_tab_entry_set_device_uuid (FsTabEntry* self,
                              const gchar* value)
{
	gchar* _tmp0_;
#line 54 "Utility/FsTabEntry.vala"
	g_return_if_fail (self != NULL);
#line 55 "Utility/FsTabEntry.vala"
	_tmp0_ = g_strdup_printf ("UUID=%s", value);
#line 55 "Utility/FsTabEntry.vala"
	_g_free0 (self->device_string);
#line 55 "Utility/FsTabEntry.vala"
	self->device_string = _tmp0_;
#line 54 "Utility/FsTabEntry.vala"
	g_object_notify_by_pspec ((GObject *) self, fs_tab_entry_properties[FS_TAB_ENTRY_DEVICE_UUID_PROPERTY]);
#line 2048 "FsTabEntry.c"
}

static void
fs_tab_entry_class_init (FsTabEntryClass * klass,
                         gpointer klass_data)
{
#line 32 "Utility/FsTabEntry.vala"
	fs_tab_entry_parent_class = g_type_class_peek_parent (klass);
#line 32 "Utility/FsTabEntry.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_fs_tab_entry_get_property;
#line 32 "Utility/FsTabEntry.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_fs_tab_entry_set_property;
#line 32 "Utility/FsTabEntry.vala"
	G_OBJECT_CLASS (klass)->finalize = fs_tab_entry_finalize;
#line 32 "Utility/FsTabEntry.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FS_TAB_ENTRY_DEVICE_UUID_PROPERTY, fs_tab_entry_properties[FS_TAB_ENTRY_DEVICE_UUID_PROPERTY] = g_param_spec_string ("device-uuid", "device-uuid", "device-uuid", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2065 "FsTabEntry.c"
}

static void
fs_tab_entry_instance_init (FsTabEntry * self,
                            gpointer klass)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
#line 34 "Utility/FsTabEntry.vala"
	self->is_comment = FALSE;
#line 35 "Utility/FsTabEntry.vala"
	self->is_empty_line = FALSE;
#line 37 "Utility/FsTabEntry.vala"
	_tmp0_ = g_strdup ("");
#line 37 "Utility/FsTabEntry.vala"
	self->device_string = _tmp0_;
#line 38 "Utility/FsTabEntry.vala"
	_tmp1_ = g_strdup ("");
#line 38 "Utility/FsTabEntry.vala"
	self->mount_point = _tmp1_;
#line 39 "Utility/FsTabEntry.vala"
	_tmp2_ = g_strdup ("");
#line 39 "Utility/FsTabEntry.vala"
	self->type = _tmp2_;
#line 40 "Utility/FsTabEntry.vala"
	_tmp3_ = g_strdup ("defaults");
#line 40 "Utility/FsTabEntry.vala"
	self->options = _tmp3_;
#line 41 "Utility/FsTabEntry.vala"
	_tmp4_ = g_strdup ("0");
#line 41 "Utility/FsTabEntry.vala"
	self->dump = _tmp4_;
#line 42 "Utility/FsTabEntry.vala"
	_tmp5_ = g_strdup ("0");
#line 42 "Utility/FsTabEntry.vala"
	self->pass = _tmp5_;
#line 43 "Utility/FsTabEntry.vala"
	_tmp6_ = g_strdup ("");
#line 43 "Utility/FsTabEntry.vala"
	self->line = _tmp6_;
#line 2111 "FsTabEntry.c"
}

static void
fs_tab_entry_finalize (GObject * obj)
{
	FsTabEntry * self;
#line 32 "Utility/FsTabEntry.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_FS_TAB_ENTRY, FsTabEntry);
#line 37 "Utility/FsTabEntry.vala"
	_g_free0 (self->device_string);
#line 38 "Utility/FsTabEntry.vala"
	_g_free0 (self->mount_point);
#line 39 "Utility/FsTabEntry.vala"
	_g_free0 (self->type);
#line 40 "Utility/FsTabEntry.vala"
	_g_free0 (self->options);
#line 41 "Utility/FsTabEntry.vala"
	_g_free0 (self->dump);
#line 42 "Utility/FsTabEntry.vala"
	_g_free0 (self->pass);
#line 43 "Utility/FsTabEntry.vala"
	_g_free0 (self->line);
#line 32 "Utility/FsTabEntry.vala"
	G_OBJECT_CLASS (fs_tab_entry_parent_class)->finalize (obj);
#line 2136 "FsTabEntry.c"
}

GType
fs_tab_entry_get_type (void)
{
	static volatile gsize fs_tab_entry_type_id__volatile = 0;
	if (g_once_init_enter (&fs_tab_entry_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (FsTabEntryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) fs_tab_entry_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FsTabEntry), 0, (GInstanceInitFunc) fs_tab_entry_instance_init, NULL };
		GType fs_tab_entry_type_id;
		fs_tab_entry_type_id = g_type_register_static (G_TYPE_OBJECT, "FsTabEntry", &g_define_type_info, 0);
		g_once_init_leave (&fs_tab_entry_type_id__volatile, fs_tab_entry_type_id);
	}
	return fs_tab_entry_type_id__volatile;
}

static void
_vala_fs_tab_entry_get_property (GObject * object,
                                 guint property_id,
                                 GValue * value,
                                 GParamSpec * pspec)
{
	FsTabEntry * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_FS_TAB_ENTRY, FsTabEntry);
#line 32 "Utility/FsTabEntry.vala"
	switch (property_id) {
#line 32 "Utility/FsTabEntry.vala"
		case FS_TAB_ENTRY_DEVICE_UUID_PROPERTY:
#line 32 "Utility/FsTabEntry.vala"
		g_value_take_string (value, fs_tab_entry_get_device_uuid (self));
#line 32 "Utility/FsTabEntry.vala"
		break;
#line 2168 "FsTabEntry.c"
		default:
#line 32 "Utility/FsTabEntry.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 32 "Utility/FsTabEntry.vala"
		break;
#line 2174 "FsTabEntry.c"
	}
}

static void
_vala_fs_tab_entry_set_property (GObject * object,
                                 guint property_id,
                                 const GValue * value,
                                 GParamSpec * pspec)
{
	FsTabEntry * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_FS_TAB_ENTRY, FsTabEntry);
#line 32 "Utility/FsTabEntry.vala"
	switch (property_id) {
#line 32 "Utility/FsTabEntry.vala"
		case FS_TAB_ENTRY_DEVICE_UUID_PROPERTY:
#line 32 "Utility/FsTabEntry.vala"
		fs_tab_entry_set_device_uuid (self, g_value_get_string (value));
#line 32 "Utility/FsTabEntry.vala"
		break;
#line 2194 "FsTabEntry.c"
		default:
#line 32 "Utility/FsTabEntry.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 32 "Utility/FsTabEntry.vala"
		break;
#line 2200 "FsTabEntry.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

