/* TeeJee.Json.c generated by valac 0.44.11, the Vala compiler
 * generated from TeeJee.Json.vala, do not modify */

/*
 * TeeJee.JsonHelper.vala
 *
 * Copyright 2012-2018 Tony George <teejeetech@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 *
 *
 */

#include <json-glib/json-glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <gee.h>
#include <glib-object.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _json_array_unref0(var) ((var == NULL) ? NULL : (var = (json_array_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

gchar* tee_jee_json_helper_json_get_string (JsonObject* jobj,
                                            const gchar* member,
                                            const gchar* def_value);
void tee_jee_logging_log_debug (const gchar* message);
gdouble tee_jee_json_helper_json_get_double (JsonObject* jobj,
                                             const gchar* member,
                                             gdouble def_value);
gboolean tee_jee_json_helper_json_get_bool (JsonObject* jobj,
                                            const gchar* member,
                                            gboolean def_value);
gint tee_jee_json_helper_json_get_int (JsonObject* jobj,
                                       const gchar* member,
                                       gint def_value);
guint64 tee_jee_json_helper_json_get_uint64 (JsonObject* jobj,
                                             const gchar* member,
                                             guint64 def_value);
GeeArrayList* tee_jee_json_helper_json_get_array (JsonObject* jobj,
                                                  const gchar* member,
                                                  GeeArrayList* def_value);

gchar*
tee_jee_json_helper_json_get_string (JsonObject* jobj,
                                     const gchar* member,
                                     const gchar* def_value)
{
	gchar* result = NULL;
#line 33 "Utility/TeeJee.Json.vala"
	g_return_val_if_fail (jobj != NULL, NULL);
#line 33 "Utility/TeeJee.Json.vala"
	g_return_val_if_fail (member != NULL, NULL);
#line 33 "Utility/TeeJee.Json.vala"
	g_return_val_if_fail (def_value != NULL, NULL);
#line 34 "Utility/TeeJee.Json.vala"
	if (json_object_has_member (jobj, member)) {
#line 75 "TeeJee.Json.c"
		const gchar* _tmp0_;
		gchar* _tmp1_;
#line 35 "Utility/TeeJee.Json.vala"
		_tmp0_ = json_object_get_string_member (jobj, member);
#line 35 "Utility/TeeJee.Json.vala"
		_tmp1_ = g_strdup (_tmp0_);
#line 35 "Utility/TeeJee.Json.vala"
		result = _tmp1_;
#line 35 "Utility/TeeJee.Json.vala"
		return result;
#line 86 "TeeJee.Json.c"
	} else {
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
#line 38 "Utility/TeeJee.Json.vala"
		_tmp2_ = g_strconcat ("Member not found in JSON object: ", member, NULL);
#line 38 "Utility/TeeJee.Json.vala"
		_tmp3_ = _tmp2_;
#line 38 "Utility/TeeJee.Json.vala"
		tee_jee_logging_log_debug (_tmp3_);
#line 38 "Utility/TeeJee.Json.vala"
		_g_free0 (_tmp3_);
#line 39 "Utility/TeeJee.Json.vala"
		_tmp4_ = g_strdup (def_value);
#line 39 "Utility/TeeJee.Json.vala"
		result = _tmp4_;
#line 39 "Utility/TeeJee.Json.vala"
		return result;
#line 105 "TeeJee.Json.c"
	}
}

static gchar*
double_to_string (gdouble self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint _tmp1__length1;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* result = NULL;
#line 938 "glib-2.0.vapi"
	_tmp0_ = g_new0 (gchar, G_ASCII_DTOSTR_BUF_SIZE);
#line 938 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 938 "glib-2.0.vapi"
	_tmp1__length1 = G_ASCII_DTOSTR_BUF_SIZE;
#line 938 "glib-2.0.vapi"
	_tmp2_ = g_ascii_dtostr (_tmp1_, (gint) G_ASCII_DTOSTR_BUF_SIZE, self);
#line 938 "glib-2.0.vapi"
	_tmp3_ = g_strdup (_tmp2_);
#line 938 "glib-2.0.vapi"
	_tmp4_ = _tmp3_;
#line 938 "glib-2.0.vapi"
	_tmp1_ = (g_free (_tmp1_), NULL);
#line 938 "glib-2.0.vapi"
	result = _tmp4_;
#line 938 "glib-2.0.vapi"
	return result;
#line 137 "TeeJee.Json.c"
}

static gboolean
double_try_parse (const gchar* str,
                  gdouble* _result_,
                  const gchar* * unparsed)
{
	gdouble _vala__result_ = 0.0;
	const gchar* _vala_unparsed = NULL;
	gchar* endptr = NULL;
	gchar* _tmp0_ = NULL;
	gdouble _tmp1_;
	gchar* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gboolean result = FALSE;
#line 948 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, FALSE);
#line 950 "glib-2.0.vapi"
	_tmp1_ = g_ascii_strtod (str, &_tmp0_);
#line 950 "glib-2.0.vapi"
	endptr = _tmp0_;
#line 950 "glib-2.0.vapi"
	_vala__result_ = _tmp1_;
#line 951 "glib-2.0.vapi"
	_tmp2_ = endptr;
#line 951 "glib-2.0.vapi"
	_tmp3_ = strlen (str);
#line 951 "glib-2.0.vapi"
	_tmp4_ = _tmp3_;
#line 951 "glib-2.0.vapi"
	if (_tmp2_ == (((gchar*) str) + _tmp4_)) {
#line 952 "glib-2.0.vapi"
		_vala_unparsed = "";
#line 953 "glib-2.0.vapi"
		result = TRUE;
#line 953 "glib-2.0.vapi"
		if (_result_) {
#line 953 "glib-2.0.vapi"
			*_result_ = _vala__result_;
#line 178 "TeeJee.Json.c"
		}
#line 953 "glib-2.0.vapi"
		if (unparsed) {
#line 953 "glib-2.0.vapi"
			*unparsed = _vala_unparsed;
#line 184 "TeeJee.Json.c"
		}
#line 953 "glib-2.0.vapi"
		return result;
#line 188 "TeeJee.Json.c"
	} else {
		gchar* _tmp5_;
#line 955 "glib-2.0.vapi"
		_tmp5_ = endptr;
#line 955 "glib-2.0.vapi"
		_vala_unparsed = (const gchar*) _tmp5_;
#line 956 "glib-2.0.vapi"
		result = FALSE;
#line 956 "glib-2.0.vapi"
		if (_result_) {
#line 956 "glib-2.0.vapi"
			*_result_ = _vala__result_;
#line 201 "TeeJee.Json.c"
		}
#line 956 "glib-2.0.vapi"
		if (unparsed) {
#line 956 "glib-2.0.vapi"
			*unparsed = _vala_unparsed;
#line 207 "TeeJee.Json.c"
		}
#line 956 "glib-2.0.vapi"
		return result;
#line 211 "TeeJee.Json.c"
	}
#line 948 "glib-2.0.vapi"
	if (_result_) {
#line 948 "glib-2.0.vapi"
		*_result_ = _vala__result_;
#line 217 "TeeJee.Json.c"
	}
#line 948 "glib-2.0.vapi"
	if (unparsed) {
#line 948 "glib-2.0.vapi"
		*unparsed = _vala_unparsed;
#line 223 "TeeJee.Json.c"
	}
}

gdouble
tee_jee_json_helper_json_get_double (JsonObject* jobj,
                                     const gchar* member,
                                     gdouble def_value)
{
	gchar* text = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gdouble double_value = 0.0;
	const gchar* _tmp4_;
	gdouble _tmp5_ = 0.0;
	gboolean _tmp6_;
	gdouble result = 0.0;
#line 43 "Utility/TeeJee.Json.vala"
	g_return_val_if_fail (jobj != NULL, 0.0);
#line 43 "Utility/TeeJee.Json.vala"
	g_return_val_if_fail (member != NULL, 0.0);
#line 44 "Utility/TeeJee.Json.vala"
	_tmp0_ = double_to_string (def_value);
#line 44 "Utility/TeeJee.Json.vala"
	_tmp1_ = _tmp0_;
#line 44 "Utility/TeeJee.Json.vala"
	_tmp2_ = tee_jee_json_helper_json_get_string (jobj, member, _tmp1_);
#line 44 "Utility/TeeJee.Json.vala"
	_tmp3_ = _tmp2_;
#line 44 "Utility/TeeJee.Json.vala"
	_g_free0 (_tmp1_);
#line 44 "Utility/TeeJee.Json.vala"
	text = _tmp3_;
#line 46 "Utility/TeeJee.Json.vala"
	_tmp4_ = text;
#line 46 "Utility/TeeJee.Json.vala"
	_tmp6_ = double_try_parse (_tmp4_, &_tmp5_, NULL);
#line 46 "Utility/TeeJee.Json.vala"
	double_value = _tmp5_;
#line 46 "Utility/TeeJee.Json.vala"
	if (_tmp6_) {
#line 47 "Utility/TeeJee.Json.vala"
		result = double_value;
#line 47 "Utility/TeeJee.Json.vala"
		_g_free0 (text);
#line 47 "Utility/TeeJee.Json.vala"
		return result;
#line 272 "TeeJee.Json.c"
	} else {
#line 50 "Utility/TeeJee.Json.vala"
		result = def_value;
#line 50 "Utility/TeeJee.Json.vala"
		_g_free0 (text);
#line 50 "Utility/TeeJee.Json.vala"
		return result;
#line 280 "TeeJee.Json.c"
	}
#line 43 "Utility/TeeJee.Json.vala"
	_g_free0 (text);
#line 284 "TeeJee.Json.c"
}

static gboolean
bool_parse (const gchar* str)
{
	gboolean result = FALSE;
#line 44 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, FALSE);
#line 45 "glib-2.0.vapi"
	if (g_strcmp0 (str, "true") == 0) {
#line 46 "glib-2.0.vapi"
		result = TRUE;
#line 46 "glib-2.0.vapi"
		return result;
#line 299 "TeeJee.Json.c"
	} else {
#line 48 "glib-2.0.vapi"
		result = FALSE;
#line 48 "glib-2.0.vapi"
		return result;
#line 305 "TeeJee.Json.c"
	}
}

gboolean
tee_jee_json_helper_json_get_bool (JsonObject* jobj,
                                   const gchar* member,
                                   gboolean def_value)
{
	gboolean result = FALSE;
#line 54 "Utility/TeeJee.Json.vala"
	g_return_val_if_fail (jobj != NULL, FALSE);
#line 54 "Utility/TeeJee.Json.vala"
	g_return_val_if_fail (member != NULL, FALSE);
#line 55 "Utility/TeeJee.Json.vala"
	if (json_object_has_member (jobj, member)) {
#line 321 "TeeJee.Json.c"
		const gchar* _tmp0_;
#line 56 "Utility/TeeJee.Json.vala"
		_tmp0_ = json_object_get_string_member (jobj, member);
#line 56 "Utility/TeeJee.Json.vala"
		result = bool_parse (_tmp0_);
#line 56 "Utility/TeeJee.Json.vala"
		return result;
#line 329 "TeeJee.Json.c"
	} else {
		gchar* _tmp1_;
		gchar* _tmp2_;
#line 59 "Utility/TeeJee.Json.vala"
		_tmp1_ = g_strconcat ("Member not found in JSON object: ", member, NULL);
#line 59 "Utility/TeeJee.Json.vala"
		_tmp2_ = _tmp1_;
#line 59 "Utility/TeeJee.Json.vala"
		tee_jee_logging_log_debug (_tmp2_);
#line 59 "Utility/TeeJee.Json.vala"
		_g_free0 (_tmp2_);
#line 60 "Utility/TeeJee.Json.vala"
		result = def_value;
#line 60 "Utility/TeeJee.Json.vala"
		return result;
#line 345 "TeeJee.Json.c"
	}
}

gint
tee_jee_json_helper_json_get_int (JsonObject* jobj,
                                  const gchar* member,
                                  gint def_value)
{
	gint result = 0;
#line 64 "Utility/TeeJee.Json.vala"
	g_return_val_if_fail (jobj != NULL, 0);
#line 64 "Utility/TeeJee.Json.vala"
	g_return_val_if_fail (member != NULL, 0);
#line 65 "Utility/TeeJee.Json.vala"
	if (json_object_has_member (jobj, member)) {
#line 361 "TeeJee.Json.c"
		const gchar* _tmp0_;
#line 66 "Utility/TeeJee.Json.vala"
		_tmp0_ = json_object_get_string_member (jobj, member);
#line 66 "Utility/TeeJee.Json.vala"
		result = atoi (_tmp0_);
#line 66 "Utility/TeeJee.Json.vala"
		return result;
#line 369 "TeeJee.Json.c"
	} else {
		gchar* _tmp1_;
		gchar* _tmp2_;
#line 69 "Utility/TeeJee.Json.vala"
		_tmp1_ = g_strconcat ("Member not found in JSON object: ", member, NULL);
#line 69 "Utility/TeeJee.Json.vala"
		_tmp2_ = _tmp1_;
#line 69 "Utility/TeeJee.Json.vala"
		tee_jee_logging_log_debug (_tmp2_);
#line 69 "Utility/TeeJee.Json.vala"
		_g_free0 (_tmp2_);
#line 70 "Utility/TeeJee.Json.vala"
		result = def_value;
#line 70 "Utility/TeeJee.Json.vala"
		return result;
#line 385 "TeeJee.Json.c"
	}
}

static guint64
uint64_parse (const gchar* str)
{
	guint64 result = 0ULL;
#line 782 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, 0ULL);
#line 783 "glib-2.0.vapi"
	result = g_ascii_strtoull (str, NULL, (guint) 0);
#line 783 "glib-2.0.vapi"
	return result;
#line 399 "TeeJee.Json.c"
}

guint64
tee_jee_json_helper_json_get_uint64 (JsonObject* jobj,
                                     const gchar* member,
                                     guint64 def_value)
{
	guint64 result = 0ULL;
#line 74 "Utility/TeeJee.Json.vala"
	g_return_val_if_fail (jobj != NULL, 0ULL);
#line 74 "Utility/TeeJee.Json.vala"
	g_return_val_if_fail (member != NULL, 0ULL);
#line 75 "Utility/TeeJee.Json.vala"
	if (json_object_has_member (jobj, member)) {
#line 414 "TeeJee.Json.c"
		const gchar* _tmp0_;
#line 76 "Utility/TeeJee.Json.vala"
		_tmp0_ = json_object_get_string_member (jobj, member);
#line 76 "Utility/TeeJee.Json.vala"
		result = uint64_parse (_tmp0_);
#line 76 "Utility/TeeJee.Json.vala"
		return result;
#line 422 "TeeJee.Json.c"
	} else {
		gchar* _tmp1_;
		gchar* _tmp2_;
#line 79 "Utility/TeeJee.Json.vala"
		_tmp1_ = g_strconcat ("Member not found in JSON object: ", member, NULL);
#line 79 "Utility/TeeJee.Json.vala"
		_tmp2_ = _tmp1_;
#line 79 "Utility/TeeJee.Json.vala"
		tee_jee_logging_log_debug (_tmp2_);
#line 79 "Utility/TeeJee.Json.vala"
		_g_free0 (_tmp2_);
#line 80 "Utility/TeeJee.Json.vala"
		result = def_value;
#line 80 "Utility/TeeJee.Json.vala"
		return result;
#line 438 "TeeJee.Json.c"
	}
}

static gpointer
_json_array_ref0 (gpointer self)
{
#line 90 "Utility/TeeJee.Json.vala"
	return self ? json_array_ref (self) : NULL;
#line 447 "TeeJee.Json.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 99 "Utility/TeeJee.Json.vala"
	return self ? g_object_ref (self) : NULL;
#line 455 "TeeJee.Json.c"
}

GeeArrayList*
tee_jee_json_helper_json_get_array (JsonObject* jobj,
                                    const gchar* member,
                                    GeeArrayList* def_value)
{
	GeeArrayList* result = NULL;
#line 84 "Utility/TeeJee.Json.vala"
	g_return_val_if_fail (jobj != NULL, NULL);
#line 84 "Utility/TeeJee.Json.vala"
	g_return_val_if_fail (member != NULL, NULL);
#line 84 "Utility/TeeJee.Json.vala"
	g_return_val_if_fail (def_value != NULL, NULL);
#line 89 "Utility/TeeJee.Json.vala"
	if (json_object_has_member (jobj, member)) {
#line 472 "TeeJee.Json.c"
		JsonArray* jarray = NULL;
		JsonArray* _tmp0_;
		JsonArray* _tmp1_;
		GeeArrayList* list = NULL;
		GeeArrayList* _tmp2_;
		JsonArray* _tmp3_;
		GList* _tmp4_;
#line 90 "Utility/TeeJee.Json.vala"
		_tmp0_ = json_object_get_array_member (jobj, member);
#line 90 "Utility/TeeJee.Json.vala"
		_tmp1_ = _json_array_ref0 (_tmp0_);
#line 90 "Utility/TeeJee.Json.vala"
		jarray = _tmp1_;
#line 91 "Utility/TeeJee.Json.vala"
		_tmp2_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 91 "Utility/TeeJee.Json.vala"
		list = _tmp2_;
#line 92 "Utility/TeeJee.Json.vala"
		_tmp3_ = jarray;
#line 92 "Utility/TeeJee.Json.vala"
		_tmp4_ = json_array_get_elements (_tmp3_);
#line 494 "TeeJee.Json.c"
		{
			GList* node_collection = NULL;
			GList* node_it = NULL;
#line 92 "Utility/TeeJee.Json.vala"
			node_collection = _tmp4_;
#line 92 "Utility/TeeJee.Json.vala"
			for (node_it = node_collection; node_it != NULL; node_it = node_it->next) {
#line 502 "TeeJee.Json.c"
				JsonNode* node = NULL;
#line 92 "Utility/TeeJee.Json.vala"
				node = (JsonNode*) node_it->data;
#line 506 "TeeJee.Json.c"
				{
					GeeArrayList* _tmp5_;
					JsonNode* _tmp6_;
					const gchar* _tmp7_;
#line 93 "Utility/TeeJee.Json.vala"
					_tmp5_ = list;
#line 93 "Utility/TeeJee.Json.vala"
					_tmp6_ = node;
#line 93 "Utility/TeeJee.Json.vala"
					_tmp7_ = json_node_get_string (_tmp6_);
#line 93 "Utility/TeeJee.Json.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp5_, _tmp7_);
#line 519 "TeeJee.Json.c"
				}
			}
#line 92 "Utility/TeeJee.Json.vala"
			(node_collection == NULL) ? NULL : (node_collection = (g_list_free (node_collection), NULL));
#line 524 "TeeJee.Json.c"
		}
#line 95 "Utility/TeeJee.Json.vala"
		result = list;
#line 95 "Utility/TeeJee.Json.vala"
		_json_array_unref0 (jarray);
#line 95 "Utility/TeeJee.Json.vala"
		return result;
#line 532 "TeeJee.Json.c"
	} else {
		gchar* _tmp8_;
		gchar* _tmp9_;
		GeeArrayList* _tmp10_;
#line 98 "Utility/TeeJee.Json.vala"
		_tmp8_ = g_strconcat ("Member not found in JSON object: ", member, NULL);
#line 98 "Utility/TeeJee.Json.vala"
		_tmp9_ = _tmp8_;
#line 98 "Utility/TeeJee.Json.vala"
		tee_jee_logging_log_debug (_tmp9_);
#line 98 "Utility/TeeJee.Json.vala"
		_g_free0 (_tmp9_);
#line 99 "Utility/TeeJee.Json.vala"
		_tmp10_ = _g_object_ref0 (def_value);
#line 99 "Utility/TeeJee.Json.vala"
		result = _tmp10_;
#line 99 "Utility/TeeJee.Json.vala"
		return result;
#line 551 "TeeJee.Json.c"
	}
}

